// AocsDataTest.cpp 
//
// Version	1.0
// Date		13.01.01
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Test program for AocsData and AocsDataPool classes
// -------------------------------------------------------------------

// Include system header files
#include <stdio.h>

#include "../../GeneralUtilities/TestSuite.h"
#include "../../GeneralUtilities/TestUtilities.h"
#include "../../GeneralInclude/CompilerSwitches.h"
#include "TestCaseAocsData_1.h"
#include "TestCaseAocsData_2.h"
#include "TestCaseAocsData_3.h"
#include "TestCaseAocsData_4.h"
#include "TestCaseAocsData_5.h"
#include "TestCaseAocsData_6.h"
#include "TestCaseAocsData_7.h"
#include "TestCaseAocsData_8.h"

// -------------------------------------------------------------------

int main(int argc, char* argv[])
{
	// Open output file (only on MS_HOST)
	FILE* out=NULL;
#ifdef MS_HOST
    if( (out  = fopen("AocsDataOut.txt","w")) == NULL )
      printf( "\nThe file 'AocsDataOut' could not be opened\n" );   
	else
      printf( "\nThe file 'AocsDataOut' was successfully opened\n" );
#endif

    printf( "\nBegin test for AocsDataOut class ...\n" );
	printTestHeader(out, "AocsDataTest");

	// Create test cases for class AocsObject
	TestCaseAocsData_1 testCase_1;
	TestCaseAocsData_2 testCase_2;
	TestCaseAocsData_3 testCase_3;
	TestCaseAocsData_4 testCase_4;
	TestCaseAocsData_5 testCase_5;
	TestCaseAocsData_6 testCase_6;
	TestCaseAocsData_7 testCase_7;
	TestCaseAocsData_8 testCase_8;

	// Create and load a test suite
	TestSuite testSuite(out);
	testSuite.loadTestCase(&testCase_1);
	testSuite.loadTestCase(&testCase_2);
	testSuite.loadTestCase(&testCase_3);
	testSuite.loadTestCase(&testCase_4);
	testSuite.loadTestCase(&testCase_5);
	testSuite.loadTestCase(&testCase_6);
	testSuite.loadTestCase(&testCase_7);
	testSuite.loadTestCase(&testCase_8);

	// Run the test suite -- this causes all test cases in
	// the test suite to be run in sequence
	testSuite.runTestSuite();

    printf( "\nTest for AocsData class ended...\n" );

	// close output file
#ifdef MS_HOST
	fclose(out); 
#endif
	return 0;
}