// AocsDataTestSuite.h 
//
// Version	1.0
// Date		11.02.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Test suite for AOCS data classes (class AocsData and its subclasses)
// -------------------------------------------------------------------

// Perform tests for AOCS data classes and write results to outFile
void aocsDataTestMaster(FILE* outFile);

// Check that the AOCS data passed as an argument is properly configured.
bool aocsDataTest_1(AocsData* d);

// Write the value of a scalar, read it back and check correctness
// The first argument is the scalar variable, the second is the AOCS clock 
// from which the time tags are derived.
bool scalarTest_1(Scalar* d, AocsClock* aocsClock);

// Check the metrics functions on scalar objects.
// The two arguments are scalar variables.
bool scalarTest_3(Scalar* d1, Scalar* d2);

// Check the metrics functions on TwoEulerAngles objects.
// The two arguments are TwoEulerAngles variables.
bool twoEulerAnglesTest_1(TwoEulerAngles* e1, TwoEulerAngles* e2);

// Check the methods to read the time tags of the data items.
// The first argument is a TwoEulerAngles variable, the second one is 
// the AOCS clock.
bool twoEulerAnglesTest_2(TwoEulerAngles* e1, DummyAocsClock* aocsClock);

// Check the methods to read the property objects.
// The first argument is a TwoEulerAngles variable, the second one is 
// the AOCS clock.
bool twoEulerAnglesTest_3(TwoEulerAngles* e1, DummyAocsClock* aocsClock,
						  ConfigurationEventRepository* configEvtRep, 
						  FailureEventRepository* failureEvtRep);

