// TestCaseAocsData_2.cpp
//
// Version	1.0
// Date		10.01.01
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#include "TestCaseAocsData_2.h"
#include "../../GeneralInclude/ClassId.h"
#include "../../GeneralInclude/Constants.h"
#include "../../AocsData/AocsData.h"
#include "../../AocsData/Scalar.h"
#include "../../AocsData/DataItemWrite.h"
#include "../../AocsData/DataItemRead.h"
#include "../../OperatingSystemObjects/DummyAocsClock.h"

// -------------------------------------------------------------------
TestCaseAocsData_2::TestCaseAocsData_2():
	TestCaseGenericSetUp(ID_AOCSDATA*10+2,"TestCaseAocsData_2") {
		return;
}

// -------------------------------------------------------------------

void TestCaseAocsData_2::runTestCase() {

	Scalar d;

	// Reset the scalar
	d.reset();

	// Get the write access to the scalar data item
	DataItemWrite w = d.getDataItemWrite(0);

	// Check that the data item has value zero (scalar was reset)
	if (w.get() != 0)
	{	setTestResult(TEST_FAILURE, "Incorrect scalar value");
		return;
	}

	// Set the data item equal to 2 and check correctness
	w.set(2);
	if (w.get() != 2)
	{	setTestResult(TEST_FAILURE, "Incorrect scalar value");
		return;
	}

	// Get read access to the scalar data item
	DataItemRead r = d.getDataItemRead(0);

	// Check correct value of data item
	if (r.get() != 2)
	{	setTestResult(TEST_FAILURE, "Incorrect scalar value");
		return;
	}

	// Check correct value of data item time tag
	if (d.getLatestTimeTag() != aocsClock.getTime())
	{	setTestResult(TEST_FAILURE, "Incorrect scalar time tag");
		return;
	}

	// If this point is reached, test was successful
	setTestResult(TEST_SUCCESS,NULL);
	return;
}
