// ThreeEulerAngles.h
//
// Version	1.0
// Date		11.07.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// AOCS data consisting of three Euler angles
// -------------------------------------------------------------------

#ifndef ThreeEulerAnglesH
#define ThreeEulerAnglesH

// -------------------------------------------------------------------

#include "../GeneralInclude/BasicTypes.h"
#include "../AocsData/AocsData.h"

// -------------------------------------------------------------------

class ThreeEulerAngles: public AocsData {			

	static int tmImageLength[NTMFORMATS];

protected :

	virtual void setTmImageLength(TelemetryFormat fmt, int v)
		{ tmImageLength[fmt] = v; }
	virtual int getLocalTelemetryImageLength(TelemetryFormat fmt)
		{ return tmImageLength[fmt]; }

public :

	ThreeEulerAngles();

	virtual int getNumberOfItems()
		{ return 3; }

};

// -------------------------------------------------------------------
#endif