// TwoEulerAngles.h
//
// Version	1.0
// Date		11.02.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// AOCS data consisting of two Euler angles
// -------------------------------------------------------------------

#ifndef TwoEulerAnglesH
#define TwoEulerAnglesH

// -------------------------------------------------------------------

#include "../GeneralInclude/BasicTypes.h"
#include "../AocsData/AocsData.h"

// -------------------------------------------------------------------

class TwoEulerAngles: public AocsData {			

	static int tmImageLength[NTMFORMATS];

protected :

	virtual void setTmImageLength(TelemetryFormat fmt, int v)
		{ tmImageLength[fmt] = v; }
	virtual int getLocalTelemetryImageLength(TelemetryFormat fmt)
		{ return tmImageLength[fmt]; }

public :

	TwoEulerAngles();

	virtual int getNumberOfItems()
		{ return 2; }

};

// -------------------------------------------------------------------
#endif