// AocsEventTest.cpp 
//
// Version	1.0
// Date		07.01.01
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Test program for event classes
// -------------------------------------------------------------------

#include <stdio.h>

#include "../../GeneralUtilities/TestSuite.h"
#include "../../GeneralUtilities/TestUtilities.h"
#include "../../GeneralInclude/CompilerSwitches.h"
#include "TestCaseAocsEvent_1.h"
#include "TestCaseAocsEvent_2.h"
#include "TestCaseAocsEvent_3.h"
#include "TestCaseAocsEvent_4.h"
#include "TestCaseAocsEvent_5.h"

// -------------------------------------------------------------------

int main(int argc, char* argv[])
{
	// Open output file (only on MS_HOST)
	FILE* out=NULL;
#ifdef MS_HOST
    if( (out  = fopen("AocsEventOut.txt","w")) == NULL )
      printf( "\nThe file 'AocsEventOut' could not be opened\n" );   
	else
      printf( "\nThe file 'AocsEventOut' was successfully opened\n" );
#endif

    printf( "\nBegin test for AocsEvent class ...\n" );
	printTestHeader(out,"AocsEventTest");

	// Create test cases for class AocsObject
	TestCaseAocsEvent_1 testCase_1;
	TestCaseAocsEvent_2 testCase_2;
	TestCaseAocsEvent_3 testCase_3;
	TestCaseAocsEvent_4 testCase_4;
	TestCaseAocsEvent_5 testCase_5;

	// Create and load a test suite
	TestSuite testSuite(out);
	testSuite.loadTestCase(&testCase_1);
	testSuite.loadTestCase(&testCase_2);
	testSuite.loadTestCase(&testCase_3);
	testSuite.loadTestCase(&testCase_4);
	testSuite.loadTestCase(&testCase_5);

	// Run the test suite -- this causes all test cases in
	// the test suite to be run in sequence
	testSuite.runTestSuite();

    printf( "\nTest for AocsEvent class ended...\n" );

	// close output file
#ifdef MS_HOST
	fclose(out); 
#endif
	return 0;
}