// TestCaseAocsEvent_3.cpp
//
// Version	1.0
// Date		07.01.01
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#include "TestCaseAocsEvent_3.h"
#include "../../GeneralInclude/ClassId.h"
#include "../../GeneralInclude/Constants.h"
#include "../../AocsEvent/FailureEventRepository.h"
#include "../../AocsEvent/ConfigurationEventRepository.h"
#include "../../AocsEvent/EventTypeId.h"
#include "../../BasicObjects/AocsObject.h"

// -------------------------------------------------------------------

TestCaseAocsEvent_3::TestCaseAocsEvent_3():
	TestCaseAocsEvent(ID_AOCSEVENT*10+3,"TestCaseAocsEvent_3") {
		return;
}

// -------------------------------------------------------------------

void TestCaseAocsEvent_3::runTestCase() {

	// Retrieve number of events in the repository
	int n = f1.getCounter();

	// Load four events into the event repository
	f1.create(NULL,DUMMY_EVENT_1,NULL,NULL);
	f1.create(NULL,DUMMY_EVENT_2,NULL,NULL);
	f1.create(NULL,DUMMY_EVENT_3,NULL,NULL);
	f1.create(NULL,DUMMY_EVENT_4,NULL,NULL);

	// Check that number of events in repository has increased by four
	if ( f1.getCounter() != (n+4) )
	{	setTestResult(TEST_FAILURE, "Wrong number of events");
		return;
	}

	// Iterate through last four events and verify that they are correct
	// NB Test assumes that event repository size is at least four
	FailureEvent* evt;
	evt = f1.latestFailureEvent();
	if (evt->getEventType() != DUMMY_EVENT_4)
	{	setTestResult(TEST_FAILURE, "Error in iteration through repository");
		return;
	}

	evt = f1.previousFailureEvent();
	if (evt->getEventType() != DUMMY_EVENT_3)
	{	setTestResult(TEST_FAILURE, "Error in iteration through repository");
		return;
	}

	evt = f1.previousFailureEvent();
	if (evt->getEventType() != DUMMY_EVENT_2)
	{	setTestResult(TEST_FAILURE, "Error in iteration through repository");
		return;
	}

	evt = f1.previousFailureEvent();
	if (evt->getEventType() != DUMMY_EVENT_1)
	{	setTestResult(TEST_FAILURE, "Error in iteration through repository");
		return;
	}

	// If this point is reached, test was successful
	setTestResult(TEST_SUCCESS,NULL);
	return;
}
