// TestCaseAocsEvent_5.cpp
//
// Version	1.0
// Date		07.01.01
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#include "TestCaseAocsEvent_5.h"
#include "../../GeneralInclude/ClassId.h"
#include "../../GeneralInclude/Constants.h"
#include "../../AocsEvent/FailureEventRepository.h"
#include "../../AocsEvent/ConfigurationEventRepository.h"
#include "../../AocsEvent/EventTypeId.h"
#include "../../BasicObjects/AocsObject.h"
#include "../../FailureDetection/ConsistencyCheckable.h"

// -------------------------------------------------------------------

TestCaseAocsEvent_5::TestCaseAocsEvent_5():
	TestCaseAocsEvent(ID_AOCSEVENT*10+5,"TestCaseAocsEvent_5") {
		return;
}

// -------------------------------------------------------------------

void TestCaseAocsEvent_5::runTestCase() {

	// reset repository
	c1.reset();

	// add one event to repository
	c1.create(NULL,DUMMY_EVENT,NULL);

	// do a consistency check
	if (!c1.doConsistencyCheck())
	{	setTestResult(TEST_FAILURE, "Consistency check on event repository failed");
		return;
	}

	// saturate repository
	for (int n=0; n<(size+1); n++)
		c1.create(NULL,DUMMY_EVENT,NULL);

	// now the consistency check should fail since some inserted events have been lost
	if (c1.doConsistencyCheck())
	{	setTestResult(TEST_FAILURE, "Consistency check on event repository failed");
		return;
	}

	// If this point is reached, test was successful
	setTestResult(TEST_SUCCESS,NULL);
	return;
}
