// ChangeEvent.h
//
// Version	1.0
// Date		29.03.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Class for change events
//
// -------------------------------------------------------------------

#ifndef ChangeEventH
#define ChangeEventH

// -------------------------------------------------------------------

#include "../GeneralInclude/ForwardDeclarations.h"
#include "../GeneralInclude/Constants.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../AocsEvent/AocsEvent.h"

// -------------------------------------------------------------------

class ChangeEvent : public AocsEvent {

	PropertyId propertyId;				// if of property that underwent change
	ChangeObject* changeObject;			// change object that detected the change
	Real lastValue;						// value at time of change

	static int tmImageLength[NTMFORMATS];

	void localResetConfiguration();		

public :

	ChangeEvent();

	void initialize(AocsObject* creator, 
					  EventType evtType,
						PropertyId propertyId, 
						  ChangeObject* changeObject,
							Real lastValue);

	PropertyId getPropertyId()
		{ return propertyId; }

	ChangeObject* getChangeObject()
		{ return changeObject; }

	Real getLastValue()
		{ return lastValue; }

	virtual void resetConfiguration();	// pure virtual methods from Configurable	
	virtual bool isConfigured();		

										// pure virtual methods from Telemeterable
	virtual void writeToTelemetry(TelemetryStream* stream);
	virtual int getTelemetryImageLength();
};

// -------------------------------------------------------------------
#endif
