// ConfigurationEvent.h
//
// Version	1.0
// Date		08.02.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Class for configuration events
//
// -------------------------------------------------------------------

#ifndef ConfigurationEventH
#define ConfigurationEventH

// -------------------------------------------------------------------

#include "../GeneralInclude/ForwardDeclarations.h"
#include "../GeneralInclude/Constants.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../AocsEvent/AocsEvent.h"

// -------------------------------------------------------------------

class ConfigurationEvent : public AocsEvent {

	AocsObject* location;				// object where configuration event happened
	static int tmImageLength[NTMFORMATS];

	void localResetConfiguration();		

public :

	ConfigurationEvent();

	void initialize(AocsObject* creator, 
					  EventType evtType,
						AocsObject* location);

	AocsObject* getLocation()
		{ return location; }

	virtual void resetConfiguration();	// pure virtual methods from Configurable	
	virtual bool isConfigured();		

										// pure virtual methods from Telemeterable
	virtual void writeToTelemetry(TelemetryStream* stream);
	virtual int getTelemetryImageLength();
};

// -------------------------------------------------------------------
#endif
