// FailureEventRepository.h
//
// Version	1.0
// Date		08.02.00
// Author	A. Pasetti
//

#ifndef FailureEventRepositoryH
#define FailureEventRepositoryH

// -------------------------------------------------------------------

#include "../GeneralInclude/ForwardDeclarations.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../AocsEvent/EventRepository.h"

// -------------------------------------------------------------------

class FailureEventRepository : public EventRepository {

	FailureEvent* buffer;

public:

	FailureEventRepository();

	void create (AocsObject* creator, 
				   EventType evtType,
					 AocsObject* failureLocation,
					   RecoveryAction* recoveryAction);

	void setRepositorySize(int n);		// allocates memory for event buffer. This method
										// can only be called once!
	
	FailureEvent* latestFailureEvent();		// methods to iterate through events in the repository
	FailureEvent* previousFailureEvent();	// events are returned starting from the most recent
	
};

// -------------------------------------------------------------------
#endif