// ManoeuvreEvent.h
//
// Version	1.0
// Date		20 Jul 2000
// Author	T. Brown
//
// -------------------------------------------------------------------
// Class for manoeuvre events
//
// -------------------------------------------------------------------

#ifndef ManoeuvreEventH
#define ManoeuvreEventH

// -------------------------------------------------------------------

#include "../GeneralInclude/ForwardDeclarations.h"
#include "../GeneralInclude/Constants.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../AocsEvent/AocsEvent.h"

// -------------------------------------------------------------------

class ManoeuvreEvent : public AocsEvent {

	Manoeuvre* manoeuvre;               // manoeuvre to which the event is related
	static int tmImageLength[NTMFORMATS];

	void localResetConfiguration();

public :
	ManoeuvreEvent();

	void initialize(AocsObject* creator,
					EventType evtType,
					Manoeuvre* m);

	Manoeuvre* getManoeuvre() 
	{
		return manoeuvre;
	}

	virtual void resetConfiguration();	// pure virtual methods from Configurable	
	virtual bool isConfigured();		

										// pure virtual methods from Telemeterable
	virtual void writeToTelemetry(TelemetryStream* stream);
	virtual int getTelemetryImageLength();
};

// -------------------------------------------------------------------
#endif // ManoeuvreEventH
