// ReconfigurationEvent.h
//
// Version	1.0
// Date		26.06.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Class for reconfiguration events
//
// -------------------------------------------------------------------

#ifndef ReconfigurationEventH
#define ReconfigurationEventH

// -------------------------------------------------------------------

#include "../GeneralInclude/ForwardDeclarations.h"
#include "../GeneralInclude/Constants.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../AocsEvent/AocsEvent.h"

// -------------------------------------------------------------------

class ReconfigurationEvent : public AocsEvent {

	static int tmImageLength[NTMFORMATS];

	ConfigurationId oldConfiguration;					
	ConfigurationId newConfiguration;					
	InstanceId configurationManagerId;

	void localResetConfiguration();		

public :

	ReconfigurationEvent();

	void initialize(AocsObject* creator, 
					  EventType evtType,
					    ConfigurationId oldConfiguration,
						  ConfigurationId newConfiguration,
					        InstanceId configurationManagerId);

	ConfigurationId getOldConfiguration()
		{ return oldConfiguration; }

	ConfigurationId getNewConfiguration()
		{ return newConfiguration; }

	InstanceId getConfigurationManagerId()
		{ return configurationManagerId; }

	// Methods inherited from interface Configurable
	virtual void resetConfiguration();		
	virtual bool isConfigured();		

	// Methods inherited from interface Telemeterable
	virtual void writeToTelemetry(TelemetryStream* stream);
	virtual int getTelemetryImageLength();
};

// -------------------------------------------------------------------
#endif
