// ReconfigurationEventRepository.h
//
// Version	1.0
// Date		26.06.00
// Author	A. Pasetti
//

#ifndef ReconfigurationEventRepositoryH
#define ReconfigurationEventRepositoryH

// -------------------------------------------------------------------

#include "../GeneralInclude/ForwardDeclarations.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../AocsEvent/EventRepository.h"

// -------------------------------------------------------------------

class ReconfigurationEventRepository : public EventRepository {

	ReconfigurationEvent* buffer;

public:

	ReconfigurationEventRepository();

	void create (AocsObject* creator, 
				  EventType evtType,
				    ConfigurationId oldConfiguration,
					  ConfigurationId newConfiguration,
				        InstanceId configurationManagerId);

	void setRepositorySize(int n);		// allocates memory for event buffer. This method
										// can only be called once!
	
	// Methods to iterate through events in the repository (starting from most recent)
	ReconfigurationEvent* latestModeEvent();	
	ReconfigurationEvent* previousModeEvent();	
	
};

// -------------------------------------------------------------------
#endif