// RecoveryEvent.h
//
// Version	1.0
// Date		08.02.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Class for failure events
//
// -------------------------------------------------------------------

#ifndef RecoveryEventH
#define RecoveryEventH

// -------------------------------------------------------------------

#include "../GeneralInclude/ForwardDeclarations.h"
#include "../GeneralInclude/Constants.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../AocsEvent/AocsEvent.h"

// -------------------------------------------------------------------

class RecoveryEvent : public AocsEvent {

	RecoveryStrategy* recoveryStrategy;			
	RecoveryAction* recoveryAction;			
	static int tmImageLength[NTMFORMATS];

	void localResetConfiguration();		

public :

	RecoveryEvent();

	void initialize(AocsObject* creator, 
					  EventType evtType,
						  RecoveryAction* recoveryAction,
							  RecoveryStrategy* recoveryStrategy);

	RecoveryStrategy* getRecoveryStrategy()
		{ return recoveryStrategy; }

	RecoveryAction* getRecoveryAction()
		{ return recoveryAction; }

	// Virtual methods inherited from interface Configurable
	virtual void resetConfiguration();		
	virtual bool isConfigured();		

	// Virtual methods inherited from interface Telemeterable
	virtual void writeToTelemetry(TelemetryStream* stream);
	virtual int getTelemetryImageLength();
};

// -------------------------------------------------------------------
#endif
