// RecoveryEventRepository.h
//
// Version	1.0
// Date		08.02.00
// Author	A. Pasetti
//

#ifndef RecoveryEventRepositoryH
#define RecoveryEventRepositoryH

// -------------------------------------------------------------------

#include "../GeneralInclude/ForwardDeclarations.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../AocsEvent/EventRepository.h"

// -------------------------------------------------------------------

class RecoveryEventRepository : public EventRepository {

	RecoveryEvent* buffer;

public:

	RecoveryEventRepository();

	void create (AocsObject* creator, 
				   EventType evtType,
					 RecoveryAction* recoveryAction,
					   RecoveryStrategy* recoveryStrategy);

	void setRepositorySize(int n);		// allocates memory for event buffer. This method
										// can only be called once!
	
	RecoveryEvent* latestRecoveryEvent();	// methods to iterate through events in the repository
	RecoveryEvent* previousRecoveryEvent();	// events are returned starting from the most recent
	
};

// -------------------------------------------------------------------
#endif