// SystemEventRepository.h
//
// Version	1.0
// Date		13.04.00
// Author	A. Pasetti
//

#ifndef SystemEventRepositoryH
#define SystemEventRepositoryH

// -------------------------------------------------------------------

#include "../GeneralInclude/ForwardDeclarations.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../AocsEvent/EventRepository.h"

// -------------------------------------------------------------------

class SystemEventRepository : public EventRepository {

	static ClassId classId;
	SystemEvent* buffer;

public:

	SystemEventRepository();

	void create (EventType evtType);

	// Allocate memory for event buffer. Method can only be called once!
	void setRepositorySize(int n);		

	SystemEvent* latestSystemEvent();		// methods to iterate through events in the repository
	SystemEvent* previousSystemEvent();		// events are returned starting from the most recent

};

// -------------------------------------------------------------------
#endif