// DmaTelemetryStreamOnGround.h
//
// Version	1.0
// Date		31.07.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
//
// Object to process the TM stream generated by a DmaTelemetryStream.
//
// -------------------------------------------------------------------

#ifndef DmaTelemetryStreamOnGroundH
#define DmaTelemetryStreamOnGroundH

// -------------------------------------------------------------------

class DmaTelemetryStreamOnGround {

	// Start address of the DMA buffer
	char* dmaBuffer;

	// Size of DMA buffer (in bytes)
	int bufferSize;

	// Offset from where the next data byte is to be read
	int nextByte;

	// Offset from where the next data bit is to be read (not used for f/w prototype)
	int nextBit;

protected :

	int readNumberOfBytes()		
		{ return dmaBuffer[1]; }
	int readNumberOfBits()
		{ return dmaBuffer[2]; }

public:

	void reset(char* dmaBuffer, int bufferSize);

	char readChar();
	float readFloat();					
	int	readInt();					
	short readShort();					
	unsigned int readUnsignedInt();			
	unsigned short readUnsignedShort();			
	unsigned char readUnsignedChar();	
	
	// Returns true when all images in the stream have been read
	bool isFinished(int tmBufferLength)
		{ return (nextByte>=tmBufferLength); }
	
	// Methods not yet implemented (not needed for prototyep fw)
	double readDouble()					
		{ return 0; }
	bool readBool()
		{ return 0; }

};

// -------------------------------------------------------------------
#endif