// AocsUnitFunctional.h
//
// Version	1.0
// Date		28.05.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// This is an interface class.
// -------------------------------------------------------------------

#ifndef AocsUnitFunctionalH
#define AocsUnitFunctionalH

// -------------------------------------------------------------------

#include "../GeneralInclude/ForwardDeclarations.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../AocsData/DataItemWrite.h"

// -------------------------------------------------------------------

class AocsUnitFunctional {

public:

	virtual void acquireFunctionalData()=0;
	virtual void sendFunctionalData()=0;
	virtual bool isAcquireTransactionFinished()=0;
	virtual bool isSendTransactionFinished()=0;
	virtual void refreshFunctionalIn()=0;
	virtual void refreshFunctionalOut()=0;
	virtual void synchronizeFunctional()=0;
	virtual bool isSynchronizeFunctionalFinished()=0;

	virtual void setFunctionalInConverter(AbstractControlChannel* c)=0;
	virtual void setFunctionalOutConverter(AbstractControlChannel* c)=0;
	virtual void setFunctionalInLink(DataItemWrite d, int i)=0;
	virtual void setFunctionalInLink(AocsData* d)=0;
	virtual void setFunctionalOutLink(DataItemWrite d, int i)=0;
	virtual void setFunctionalOutLink(AocsData* d)=0;
	virtual DataItemWrite getFunctionalInLink(int i)=0;
	virtual DataItemWrite getFunctionalOutLink(int i)=0;

};

// -------------------------------------------------------------------
#endif