// AocsUnitHardware.h
//
// Version	1.0
// Date		27.05.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// This is an interface class.
// This interface models the hardware interface with external AOCS 
// units. Not all hardware interface will be capable of providing
// meaningful operations for all operations declared below.
// -------------------------------------------------------------------

#ifndef AocsUnitHardwareH
#define AocsUnitHardwareH

// -------------------------------------------------------------------

#include "../GeneralInclude/BasicTypes.h"

// -------------------------------------------------------------------

class AocsUnitHardware {

public:

	virtual void switchOn()=0;
	virtual void switchOff()=0;
	virtual bool isSwitchOn()=0;

	virtual void resetInterface()=0;

	virtual void resetTransaction()=0;
	virtual bool sendAndWait(UnitInstruction instr)=0;
	virtual void sendAndReturn(UnitInstruction instr)=0;
	virtual bool isTransactionFinished()=0;
	virtual bool wasTransactionSuccessful()=0;

	virtual int getAddress()=0;

};

// -------------------------------------------------------------------
#endif