// AocsUnitHousekeeping.h
//
// Version	1.0
// Date		28.05.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// This is an interface class.
// -------------------------------------------------------------------

#ifndef AocsUnitHousekeepingH
#define AocsUnitHousekeepingH

// -------------------------------------------------------------------

#include "../GeneralInclude/ForwardDeclarations.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../AocsData/DataItemWrite.h"
#include "../ObjectMonitoring/Property.h"

// -------------------------------------------------------------------

class AocsUnitHousekeeping {

public:

	virtual void initialize()=0;
	virtual bool isInitialized()=0;

	virtual void selfTest()=0;
	virtual bool isSelfTestFinished()=0;
	virtual int getSelfTestResults()=0;

	virtual void resetUnit()=0;
	virtual void resetTransaction()=0;

	virtual void acquireHousekeepingData()=0;
	virtual bool isHousekeepingTransactionFinished()=0;
	virtual void refreshHousekeepingIn()=0;

	virtual void setHousekeepingInConverter(AbstractControlChannel* c)=0;
	virtual void setHousekeepingInLink(DataItemWrite d, int i)=0;
	virtual void setHousekeepingInLink(AocsData* d)=0;
	virtual DataItemWrite getHousekeepingInLink(int i)=0;

	virtual void synchronizeHousekeeping()=0;
	virtual bool isSynchronizeHousekeepingFinished()=0;

	virtual void switchOn()=0;
	virtual void switchOff()=0;
	virtual bool isSwitchOn()=0;

	virtual void setMode(int newMode)=0;

	virtual bool isUnitHealthy()=0;
	virtual Property getHealthProperty()=0;
	virtual void addHealthMonitor(PropertyMonitor* monitor, ChangeObject* changeObject)=0;
	virtual void removeHealthMonitor(PropertyMonitor* monitor)=0;

	virtual void setHwFailureRecoveryAction(RecoveryAction* r)=0;
	virtual RecoveryAction* getHwFailureRecoveryAction()=0;

};

// -------------------------------------------------------------------
#endif