// AocsUnitTest.cpp 
//
// Version	1.0
// Date		05.02.01
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Test program for the unit framelet
// -------------------------------------------------------------------

// Include system header files
#include <stdio.h>

#include "../../GeneralUtilities/TestSuite.h"
#include "../../GeneralUtilities/TestUtilities.h"
#include "../../GeneralInclude/CompilerSwitches.h"
#include "TestCaseAocsUnit_1.h"
#include "TestCaseAocsUnit_2.h"
#include "TestCaseAocsUnit_3.h"
#include "TestCaseAocsUnit_4.h"
#include "TestCaseAocsUnit_5.h"
#include "TestCaseAocsUnit_6.h"
#include "TestCaseAocsUnit_7.h"
#include "TestCaseAocsUnit_8.h"

// -------------------------------------------------------------------

int main(int argc, char* argv[])
{
	// Open output file (only on MS_HOST)
	FILE* out=NULL;
#ifdef MS_HOST
    if( (out  = fopen("AocsUnitTestOut.txt","w")) == NULL )
      printf( "\nThe file 'AocsUnitTestOut' could not be opened\n" );   
	else
      printf( "\nThe file 'AocsUnitTestOut' was successfully opened\n" );
#endif

    printf( "\nBegin test for the Aocs Unit framelet ...\n" );
	printTestHeader(out, "AocsUnitTest");

	// Create test cases 
	TestCaseAocsUnit_1 testCase_1;
	TestCaseAocsUnit_2 testCase_2;
	TestCaseAocsUnit_3 testCase_3;
	TestCaseAocsUnit_4 testCase_4;
	TestCaseAocsUnit_5 testCase_5;
	TestCaseAocsUnit_6 testCase_6;
	TestCaseAocsUnit_7 testCase_7;
	TestCaseAocsUnit_8 testCase_8;

	// Create and load a test suite
	TestSuite testSuite(out);
	testSuite.loadTestCase(&testCase_1);
	testSuite.loadTestCase(&testCase_2);
	testSuite.loadTestCase(&testCase_3);
	testSuite.loadTestCase(&testCase_4);
	testSuite.loadTestCase(&testCase_5);
	testSuite.loadTestCase(&testCase_6);
	testSuite.loadTestCase(&testCase_7);
	testSuite.loadTestCase(&testCase_8);

	// Run the test suite -- this causes all test cases in
	// the test suite to be run in sequence
	testSuite.runTestSuite();

    printf( "\nTest for the Aocs Unit framelet ended...\n" );

	// close output file
#ifdef MS_HOST
	fclose(out); 
#endif
	return 0;
}