// GyrPrototype.cpp
//
// Version	1.0
// Date		31.05.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------

// Include framework header files
#include "../AocsUnit/GyrPrototype.h"			
#include "../AocsUnit/AocsUnitHardware.h"
#include "../AocsUnit/MacsConstants.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../GeneralInclude/Constants.h"
#include "../GeneralInclude/ClassId.h"
#include "../AocsEvent/EventTypeId.h"

// -------------------------------------------------------------------

GyrPrototype::GyrPrototype(unsigned short a, 
							unsigned short b):
					AocsUnit(0,0,1,1,0,0)
{
	setClassId(ID_RWPROTOTYPE);			

	address = a;
	angle = b;
}

// -------------------------------------------------------------------
// Send the MACS RC to initialize the MACS bus head of the GYR

void GyrPrototype::initialize()
{
	UnitInstruction instr={MACS_INSTR,address,1,MACS_RC,(unsigned short*)fcHwInpBuf,0};
	if (!hwUnit->sendAndWait(instr))
		reportFailure(this,NO_BUS_TRANSMISSION,this,hwFailureRecAct);
	return;
}

// -------------------------------------------------------------------
// Send a MACS TI instructions to the subaddresses identifying the 
// rate measurement. 

void GyrPrototype::acquireFunctionalData()
{
	UnitInstruction instr;
	
	instr.priority = MACS_INSTR;
	instr.destAddress = address;
	instr.subAddress = angle;
	instr.command = MACS_TI;
	instr.data=(unsigned short*)&fcHwInpBuf[0];

	if (!hwUnit->sendAndWait(instr))		
		reportFailure(this,NO_BUS_TRANSMISSION,this,hwFailureRecAct);

	return;
}




