// AocsObjectTest.cpp 
//
// Version	1.0
// Date		06.01.01
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Test program for class AocsObject
// -------------------------------------------------------------------

#include <stdio.h>

#include "../../GeneralUtilities/TestSuite.h"
#include "../../GeneralUtilities/TestUtilities.h"
#include "../../GeneralInclude/CompilerSwitches.h"
#include "TestCaseAocsObject_1.h"
#include "TestCaseAocsObject_2.h"
#include "TestCaseAocsObject_3.h"
#include "TestCaseRootObject_1.h"
#include "TestCaseRootObject_2.h"

// -------------------------------------------------------------------

int main(int argc, char* argv[])
{
	// Open output file (only on MS_HOST)
	FILE* out=NULL;
#ifdef MS_HOST
    if( (out  = fopen("BasicObjectsOut.txt","w")) == NULL )
      printf( "\nThe file 'BasicObjectsOut' could not be opened\n" );   
	else
      printf( "\nThe file 'BasicObjectsOut' was successfully opened\n" );
#endif

    printf( "\nBegin test for AocsObject and RootObject classes ...\n" );
	printTestHeader(out,"BasicObjectsTest");

	// Create test cases for class AocsObject
	TestCaseRootObject_1 testCase_1;
	TestCaseRootObject_2 testCase_2;
	TestCaseAocsObject_1 testCase_3;
	TestCaseAocsObject_2 testCase_4;
	TestCaseAocsObject_3 testCase_5;

	// Create and load a test suite
	TestSuite testSuite(out);
	testSuite.loadTestCase(&testCase_1);
	testSuite.loadTestCase(&testCase_2);
	testSuite.loadTestCase(&testCase_3);
	testSuite.loadTestCase(&testCase_4);
	testSuite.loadTestCase(&testCase_5);

	// Run the test suite -- this causes all test cases in
	// the test suite to be run in sequence
	testSuite.runTestSuite();

    printf( "\nTest for AocsObject and RootObject classes ended...\n" );

	// close output file
#ifdef MS_HOST
	fclose(out); 
#endif
	return 0;
}