// TestCaseAocsObject.h
//
// Version	1.0
// Date		06.01.01
// Author	A. Pasetti
//
// -------------------------------------------------------------------
//
// Abstract base class for test cases for class AocsObject.
//
// -------------------------------------------------------------------

#ifndef TestCaseAocsObjectH
#define TestCaseAocsObjectH

#include "../../GeneralUtilities/TestCase.h"
#include "../../AocsEvent/FailureEventRepository.h"
#include "../../BasicObjects/AocsObject.h"
#include "../../BasicObjects/DummyAocsObject.h"
#include "../../OperatingSystemObjects/DummyAocsClock.h"

// -------------------------------------------------------------------

class TestCaseAocsObject : public TestCase {

protected :
	
	DummyAocsClock aocsClock;
	FailureEventRepository failureEvtRep;

	AocsObject a1,a2,a3;

	DummyAocsObject da;

public :

	TestCaseAocsObject(int testId, char* testName):
	   TestCase(testId,testName)
	   { return; }

	virtual bool setUpTestCase();

	virtual void runTestCase()
		{ return; }
	
	virtual bool shutDownTestCase()
		{ return SHUTDOWN_SUCCESS; }

};

// -------------------------------------------------------------------

#endif