// TestCaseAocsObject_3.cpp
//
// Version	1.0
// Date		06.01.01
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#include "TestCaseAocsObject_3.h"
#include "../../GeneralInclude/ClassId.h"
#include "../../GeneralInclude/Constants.h"
#include "../../BasicObjects/AocsObject.h"
#include "../../BasicObjects/DummyAocsObject.h"
#include "../../OperatingSystemObjects/DummyAocsClock.h"

// -------------------------------------------------------------------
TestCaseAocsObject_3::TestCaseAocsObject_3():
	TestCaseAocsObject(ID_AOCSOBJECT*10+3,"TestCaseAocsObject_3") {
		return;
}

// -------------------------------------------------------------------

void TestCaseAocsObject_3::runTestCase() {

	aocsClock.reset();

	// Plug clock into AocsObject
	da.resetConfiguration();
	da.setAocsClock(&aocsClock);

	// Force clock to advance by two cycles
	aocsClock.run(0);
	aocsClock.run(0);

	// Check the correct clock operation
	AocsTime expTime = 2*dummyPeriod;
	if (!da.testClock(expTime, 2))
	{	setTestResult(TEST_FAILURE, "Incorrect operation of dummy Aocs clock");
		return;
	}

	setTestResult(TEST_SUCCESS,NULL);
	return;
}
