// DummyAocsObject.cpp
//
// Version	1.0
// Date		07.02.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#include "../GeneralInclude/Constants.h"
#include "../GeneralInclude/ClassId.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../GeneralInclude/ForwardDeclarations.h"
#include "../BasicObjects/Configurable.h"
#include "../TelemetryManagement/Telemeterable.h"
#include "../BasicObjects/Resettable.h"
#include "../BasicObjects/RootObject.h"
#include "../BasicObjects/AocsObject.h"
#include "DummyAocsObject.h"

// -------------------------------------------------------------------
// Define static variables
int DummyAocsObject::tmImageLength[NTMFORMATS];

// -------------------------------------------------------------------
// Default constructor.

DummyAocsObject::DummyAocsObject()
{
	setClassId(ID_DUMMYAOCSOBJECT);		// assign class identifier

	tmImageLength[shortTm]  = 0;	
	tmImageLength[normalTm] = 0;
	tmImageLength[longTm]   = 0;
	tmImageLength[debugTm]  = 0;
}

// -------------------------------------------------------------------
bool DummyAocsObject::testClock(AocsTime expectedTime, AocsCycle expectedCycle)
{
	if (getTime() != expectedTime)
		return false;

	if (getCycle() != expectedCycle)
		return false;

	return true;
}