// RootObject.h
//
// Version	1.0
// Date		12.01.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
//
// Instance identifiers are assigned in sequence as objects are created.
// Class identifiers are set by derived classes using the protected 
// setClassId method.
//
// -------------------------------------------------------------------

#ifndef RootObjectH
#define RootObjectH

// -------------------------------------------------------------------

#include "../GeneralInclude/BasicTypes.h"

// -------------------------------------------------------------------

class RootObject {

	InstanceId instanceId;
	ClassId classId;
	static InstanceId instanceCounter;		

protected :

	void setClassId(ClassId id)
			{ classId = id; }

public :

	RootObject();

	InstanceId getInstanceId()	
		{ return instanceId; }

	ClassId getClassId()		
		{ return classId; }

};

// -------------------------------------------------------------------

#endif