// ControllerManagementTest.cpp 
//
// Version	1.0
// Date		12.10.00
// Author	T. Brown
//
// -------------------------------------------------------------------
// Test program for the Controller Management framelet
// -------------------------------------------------------------------

// Include system header files
#include <stdio.h>

#include "../../GeneralUtilities/TestSuite.h"
#include "../../GeneralUtilities/TestUtilities.h"
#include "../../GeneralInclude/CompilerSwitches.h"
#include "TestCaseController_0.h"
#include "TestCaseController_1.h"
#include "TestCaseController_2.h"
#include "TestCaseController_3.h"
#include "TestCaseController_4.h"
#include "TestCaseController_5.h"

// -------------------------------------------------------------------

int main(int argc, char* argv[])
{
	// Open output file (only on MS_HOST)
	FILE* out=NULL;
#ifdef MS_HOST
    if( (out  = fopen("ControllerTestOut.txt","w")) == NULL )
      printf( "\nThe file 'ControllerTestOut' could not be opened\n" );   
	else
      printf( "\nThe file 'ControllerTestOut' was successfully opened\n" );
#endif

    printf( "\nBegin test for the Controller framelet ...\n" );
	printTestHeader(out, "ControllerTest");

	// Create test cases 
	TestCaseController_0 testCase_0;
	TestCaseController_1 testCase_1;
	TestCaseController_2 testCase_2;
	TestCaseController_3 testCase_3;
	TestCaseController_4 testCase_4;
	TestCaseController_5 testCase_5;

	// Create and load a test suite
	TestSuite testSuite(out);
	testSuite.loadTestCase(&testCase_1);
	testSuite.loadTestCase(&testCase_2);
	testSuite.loadTestCase(&testCase_3);
	testSuite.loadTestCase(&testCase_4);
	testSuite.loadTestCase(&testCase_5);

	// Run the test suite -- this causes all test cases in
	// the test suite to be run in sequence
	testSuite.runTestSuite();

    printf( "\nTest for the Controller framelet ended...\n" );

	// close output file
#ifdef MS_HOST
	fclose(out); 
#endif
	return 0;
}