// FailureDetectionManagementTest.cpp 
//
// Version	1.0
// Date		28.01.01
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Test program for the failure detection management framelet
// -------------------------------------------------------------------

// Include system header files
#include <stdio.h>

#include "../../GeneralUtilities/TestSuite.h"
#include "../../GeneralUtilities/TestUtilities.h"
#include "../../GeneralInclude/CompilerSwitches.h"
#include "TestCaseFailureDetection_1.h"
#include "TestCaseFailureDetection_2.h"
#include "TestCaseFailureDetection_3.h"

// -------------------------------------------------------------------

int main(int argc, char* argv[])
{
	// Open output file (only on MS_HOST)
	FILE* out=NULL;
#ifdef MS_HOST
    if( (out  = fopen("FailureDetectionTestOut.txt","w")) == NULL )
      printf( "\nThe file 'FailureDetectionTestOut' could not be opened\n" );   
	else
      printf( "\nThe file 'FailureDetectionTestOut' was successfully opened\n" );
#endif

    printf( "\nBegin test for failure detection framelet ...\n" );
	printTestHeader(out, "FailureDetectionTest");

	// Create test cases 
	TestCaseFailureDetection_1 testCase_1;
	TestCaseFailureDetection_2 testCase_2;
	TestCaseFailureDetection_3 testCase_3;

	// Create and load a test suite
	TestSuite testSuite(out);
	testSuite.loadTestCase(&testCase_1);
	testSuite.loadTestCase(&testCase_2);
	testSuite.loadTestCase(&testCase_3);

	// Run the test suite -- this causes all test cases in
	// the test suite to be run in sequence
	testSuite.runTestSuite();

    printf( "\nTest for failure detection framelet ended...\n" );

	// close output file
#ifdef MS_HOST
	fclose(out); 
#endif
	return 0;
}