// FollowerFailureDetectionModeManager.h
//
// Version	1.0
// Date		05.05.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Class for the follower failure detection mode manager.
// This mode manager is built on the follower mode manager. 
// When the monitoring check list is changed, all the change objects in
// the list are reset.
//
// -------------------------------------------------------------------

#ifndef FollowerFailureDetectionModeManagerH
#define FollowerFailureDetectionModeManagerH

// -------------------------------------------------------------------

#include "../GeneralInclude/ForwardDeclarations.h"
#include "../ModeManagement/FollowerModeManager.h"
#include "../FailureDetection/FailureDetectionModeManager.h"

// -------------------------------------------------------------------

class FollowerFailureDetectionModeManager : public FollowerModeManager,
											public FailureDetectionModeManager {

	ObjectListTemplate<MonitoringCheck>* oldMonitoringCheckList;

public :

	// Constructor
	FollowerFailureDetectionModeManager(int numberOfModes, 
				 						 int maxNumberOfMonitors,
										  ModeManager* masterModeManager);

	// Configuration method to load the implementers
	virtual void loadConsistencyCheckableList(int mode, ObjectListTemplate<ConsistencyCheckable>* l);
	virtual void loadMonitoringCheckList(int mode, ObjectListTemplate<MonitoringCheck>* l);

	// Strategy getter methods
	virtual ObjectListTemplate<ConsistencyCheckable>* getConsistencyCheckableList();
	virtual ObjectListTemplate<MonitoringCheck>* getMonitoringCheckList();

};

// -------------------------------------------------------------------
#endif
