// MonitoringCheck.cpp
//
// Version	1.0
// Date		05.05.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#include "../GeneralInclude/Include.h"
#include "../TelemetryManagement/Telemeterable.h"
#include "../BasicObjects/Include.h"
#include "../OperatingSystemObjects/Runnable.h"
#include "../ObjectMonitoring/Include.h"
#include "../ObjectList/Include.h"
#include "../ModeManagement/Include.h"
#include "../FailureDetection/Include.h"
#include "../AocsEvent/Include.h"

// -------------------------------------------------------------------
// Define static variables
int MonitoringCheck::tmImageLength[NTMFORMATS];

// -------------------------------------------------------------------

MonitoringCheck::MonitoringCheck(Property p, ChangeObject* c, RecoveryAction* r)
{
	setClassId(ID_MONITORINGCHECK);			

	tmImageLength[shortTm]  = 0;	
	tmImageLength[normalTm] = 0;
	tmImageLength[longTm]   = sizeof(Real)+
								sizeof(ChangeObject*)+
								  sizeof(RecoveryAction*);
	tmImageLength[debugTm]  = tmImageLength[longTm] ;
	
	monitoredProperty = p;
	changeObject = c;
	recoveryAction = r;
}

// -------------------------------------------------------------------
// From Telemeterable interface

int MonitoringCheck::getTelemetryImageLength()
{
	return (tmImageLength[getTelemetryFormat()]
								+AocsObject::getTelemetryImageLength());
}

// -------------------------------------------------------------------
// From Telemeterable interface

void MonitoringCheck::writeToTelemetry(TelemetryStream* tmStream)
{
	AocsObject::writeToTelemetry(tmStream);		// write super object's state

	// TBD : not implemented in framework prototype
}
