// FailureRecoveryManagementTest.cpp 
//
// Version	1.0
// Date		03.02.01
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Test program for the failure recovery management framelet
// -------------------------------------------------------------------

// Include system header files
#include <stdio.h>

#include "../../GeneralUtilities/TestSuite.h"
#include "../../GeneralUtilities/TestUtilities.h"
#include "../../GeneralInclude/CompilerSwitches.h"
#include "TestCaseFailureRecovery_1.h"
#include "TestCaseFailureRecovery_2.h"
#include "TestCaseFailureRecovery_3.h"

// -------------------------------------------------------------------

int main(int argc, char* argv[])
{
	// Open output file (only on MS_HOST)
	FILE* out=NULL;
#ifdef MS_HOST
    if( (out  = fopen("FailureRecoveryManagementTestOut.txt","w")) == NULL )
      printf( "\nThe file 'FailureRecoveryManagementTestOut' could not be opened\n" );   
	else
      printf( "\nThe file 'FailureRecoveryManagementTestOut' was successfully opened\n" );
#endif

    printf( "\nBegin test for the failure recovery management framelet ...\n" );
	printTestHeader(out, "FailureRecoveryManagementTest");

	// Create test cases 
	TestCaseFailureRecovery_1 testCase_1;
	TestCaseFailureRecovery_2 testCase_2;
	TestCaseFailureRecovery_3 testCase_3;

	// Create and load a test suite
	TestSuite testSuite(out);
	testSuite.loadTestCase(&testCase_1);
	testSuite.loadTestCase(&testCase_2);
	testSuite.loadTestCase(&testCase_3);

	// Run the test suite -- this causes all test cases in
	// the test suite to be run in sequence
	testSuite.runTestSuite();

    printf( "\nTest for the failure recovery management framelet ended...\n" );

	// close output file
#ifdef MS_HOST
	fclose(out); 
#endif
	return 0;
}