// ModeChange.h
//
// Version	1.0
// Date		10.05.00
// Author	A. Pasetti
//

#ifndef ModeChangeH
#define ModeChangeH

// -------------------------------------------------------------------
// Mode change recovery action.
// A call to doRecovery causes a mode change to be commanded to the 
// mode manager passed as parameter to the constructor.
// -------------------------------------------------------------------

#include "../FailureRecovery/RecoveryAction.h"
#include "../GeneralInclude/ForwardDeclarations.h"

// -------------------------------------------------------------------

class ModeChange : public RecoveryAction {

	ModeManager* modeManager;
	int newMode;

public :

	ModeChange(ModeManager* modeManager, int newMode);

	virtual void doRecovery();

};

// -------------------------------------------------------------------
#endif