// Reconfiguration.h
//
// Version	1.0
// Date		10.05.00
// Author	A. Pasetti
//

#ifndef ReconfigurationH
#define ReconfigurationH

// -------------------------------------------------------------------
// Reconfiguration recovery action.
// A call to doRecovery causes a reconfiguration to be commanded to the
// object passed as parameter to the constructor.
// If the reconfiguration cannot be performed, then the next recovery 
// action is executed (if it is present)
// -------------------------------------------------------------------

#include "../FailureRecovery/RecoveryAction.h"
#include "../GeneralInclude/ForwardDeclarations.h"

// -------------------------------------------------------------------

class Reconfiguration : public RecoveryAction {

	Reconfigurable* objectToBeReconfigured;

public :

	Reconfiguration(Reconfigurable* objectToBeReconfigured);

	virtual void doRecovery();
};

// -------------------------------------------------------------------
#endif