// RecoveryAction.h
//
// Version	1.0
// Date		10.05.00
// Author	A. Pasetti

#ifndef RecoveryActionH
#define RecoveryActionH

// -------------------------------------------------------------------
// Base class for recovery actions.
// -------------------------------------------------------------------

#include "../GeneralInclude/ForwardDeclarations.h"
#include "../GeneralInclude/Constants.h"
#include "../BasicObjects/AocsObject.h"

// -------------------------------------------------------------------

class RecoveryAction : public AocsObject {

	static int tmImageLength[NTMFORMATS];

	bool enabled;
	RecoveryAction* nextRecoveryAction;

	void localReset();
	void localResetConfiguration();

public :

	RecoveryAction();

	virtual void doRecovery();

	// Virtual methods inherited from interface Configurable
	virtual void resetConfiguration();		

	// Virtual methods inherited from interface Resettable
	virtual void reset();		
	
	// Virtual methods inherited from interface Telemeterable
	virtual void writeToTelemetry(TelemetryStream* stream);
	virtual int getTelemetryImageLength();

	// Straightforward getter and setter methods
	void setNextRecoveryAction(RecoveryAction* r)
		{ nextRecoveryAction = r; }
	RecoveryAction* getNextRecoveryAction()
		{ return nextRecoveryAction; }

	// Methods to manage the enable status
	void enable()
		{ enabled = true; }
	void disable()
		{ enabled = false; }
	bool isEnabled()
		{ return enabled; }
};

// -------------------------------------------------------------------
#endif