// SystemResetOnConfigurationError.h
//
// Version	1.0
// Date		28.07.00
// Author	A. Pasetti

#ifndef SystemResetOnConfigurationErrorH
#define SystemResetOnConfigurationErrorH

// -------------------------------------------------------------------
// Recovery strategy that commands a system reset if a configuration
// error is found in the configuration error repository.
// -------------------------------------------------------------------

#include "../FailureRecovery/RecoveryStrategy.h"
#include "../GeneralInclude/BasicTypes.h"

// -------------------------------------------------------------------

class SystemResetOnConfigurationError : public RecoveryStrategy {

	static ClassId classId;

	void localReset();
	void localResetConfiguration();

public :

	SystemResetOnConfigurationError();

	virtual void doRecovery();
};

// -------------------------------------------------------------------
#endif