// FlushMacsBuffers.cpp 
//
// Version	1.0
// Date		04.08.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Sends content of the accumulated MACS buffers to output device.
// -------------------------------------------------------------------

#include "../GeneralUtilities/FlushMacsBuffers.h"
#include "../GeneralUtilities/TestUtilities.h"

// -------------------------------------------------------------------

void flushMacsBuffers(FILE* out, AocsTestHarness* aocsTestHarness)
{
	// Print header with the output format
	printString(out,"RW1 Torque - RW4 Torque, SapA1 DelTime - SapA6 DelTime,");
	printString(out,"SapA1 OnTime - SapA6 OnTime, SapB1 DelTime - SapB6 DelTime,");
	printString(out,"SapB1 OnTime - SapB6 OnTime \n");

	// Recover the array holding the copies of the MACS buffers
	unsigned short* macsBuffer = aocsTestHarness->getMacsBuffer();

	// Iterate on the TM buffers
	for (int i=0; i<aocsTestHarness->getNumberOfMacsBuffers(); i++)
	{	
		printString(out,"MACS Buffers: ");
		printInt(out,i);
		printString(out,"\n");
			
		// Iterate on the words in each saved MACS buffer
		for (int j=0; j<aocsTestHarness->getNumberOfMacsWords(); j++)
			printWord(out,macsBuffer[i*aocsTestHarness->getNumberOfMacsWords()+j]);

		printString(out,"\n");
	}
}