// TestSuite.h
//
// Version	1.0
// Date		12.12.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
//
// A test suite is a collection of test cases that are intended to be
// executed as a single unit.
//
// -------------------------------------------------------------------

#ifndef TestSuiteH
#define TestSuiteH

// -------------------------------------------------------------------

class TestCase;
#define MAX_TEST_CASES_IN_SUITE 200
#include <stdio.h>

// -------------------------------------------------------------------

class TestSuite {

	TestCase* list[MAX_TEST_CASES_IN_SUITE];
	int testCaseCounter;
	FILE* out;					// test messages are written here

public :

	TestSuite(FILE* out);

	// Execute all test cases in the test suite
	void runTestSuite();
	
	// Load a test case in the test suite
	void loadTestCase(TestCase* newTestCase);
};

// -------------------------------------------------------------------

#endif