// ManoeuvreManagementTest.cpp 
//
// Version	1.0
// Date		16.07.00
// Author	T. Brown/A. Pasetti
//
// -------------------------------------------------------------------
// Test program for the Manoeuvre Management framelet
// -------------------------------------------------------------------

// Include system header files
#include <stdio.h>

#include "../../GeneralUtilities/TestSuite.h"
#include "../../GeneralUtilities/TestUtilities.h"
#include "../../GeneralInclude/CompilerSwitches.h"
#include "TestCaseManoeuvre_1.h"
#include "TestCaseManoeuvre_2.h"
#include "TestCaseManoeuvre_3.h"
#include "TestCaseManoeuvre_4.h"

// -------------------------------------------------------------------

int main(int argc, char* argv[])
{
	// Open output file (only on MS_HOST)
	FILE* out=NULL;
#ifdef MS_HOST
    if( (out  = fopen("ManoeuvreTestOut.txt","w")) == NULL )
      printf( "\nThe file 'ManoeuvreTestOut' could not be opened\n" );   
	else
      printf( "\nThe file 'ManoeuvreTestOut' was successfully opened\n" );
#endif

    printf( "\nBegin test for the Manoeuvre framelet ...\n" );
	printTestHeader(out, "ManoeuvreTest");

	// Create test cases 
	TestCaseManoeuvre_1 testCase_1;
	TestCaseManoeuvre_2 testCase_2;
	TestCaseManoeuvre_3 testCase_3;
	TestCaseManoeuvre_4 testCase_4;

	// Create and load a test suite
	TestSuite testSuite(out);
	testSuite.loadTestCase(&testCase_1);
	testSuite.loadTestCase(&testCase_2);
	testSuite.loadTestCase(&testCase_3);
	testSuite.loadTestCase(&testCase_4);

	// Run the test suite -- this causes all test cases in
	// the test suite to be run in sequence
	testSuite.runTestSuite();

    printf( "\nTest for the Manoeuvre framelet ended...\n" );

	// close output file
#ifdef MS_HOST
	fclose(out); 
#endif
	return 0;
}