// ManoeuvreManagementTestSuite.h
//
// Version  1.0
// Date     17 Jul 2000
// Author   T. Brown
//
// -------------------------------------------------------------------
// Test suite for the manoeuvre management framelet - helper routines
// called by test cases
// -------------------------------------------------------------------

#include "../../GeneralInclude/ForwardDeclarations.h"
#include "../../GeneralInclude/BasicTypes.h"

#ifndef ManoeuvreManagementTestSuiteH
#define ManoeuvreManagementTestSuiteH

char* describeTMMode(TelemetryFormat fmode);

bool testManoeuvreTMLength(  TelemetryFormat fmode, AocsObject* ao, Manoeuvre* m);

bool testManoeuvreEventTMLength(  TelemetryFormat fmode,
                                AocsEvent* aoe, ManoeuvreEvent* me);

bool verifyLatestConfigurationEvent( 
                                    ConfigurationEvent* ce,
                                    AocsTime expectedTime,
                                    int expectedType,
                                    void* expectedCreator,
                                    void* expectedLocation);

bool checkDummyManoeuvreState(  Manoeuvre* m, AocsTime curTime,
                              AocsTime startTime, int stepCount, int clockPeriod);

bool AreValuesClose(Real val1, Real val2, Real threshold);

bool checkSlew(AocsTime curTime, AocsTime actualStartTime, AocsTime endTime,
               Real curValue, Real initialValue, Real endValue,
               Real changePerCycle, int cyclePeriod);

#endif // ManoeuvreManagementTestSuiteH

