// TestCaseManoeuvre_1.cpp
//
// Version	1.0
// Date		06.02.01
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#include "TestCaseManoeuvre_1.h"
#include "ManoeuvreManagementTestSuite.h"
#include "../../GeneralInclude/ClassId.h"
#include "../../GeneralInclude/Constants.h"
#include "../../AocsEvent/AocsEvent.h"
#include "../../AocsEvent/ManoeuvreEvent.h"
#include "../../ManoeuvreManagement/DummyManoeuvre.h"

// -------------------------------------------------------------------
TestCaseManoeuvre_1::TestCaseManoeuvre_1():
	TestCaseGenericSetUp(ID_MANOEUVREMANAGER*10+1,
									"TestCaseManoeuvre_1") {
		return;
}

// -------------------------------------------------------------------

void TestCaseManoeuvre_1::runTestCase() {

    // Create an AocsObject
    AocsObject ao;

    // Create a dummy Manoeuvre
    DummyManoeuvre dummyManoeuvre(10, 25);

    // Check TM image lengths

    if (!testManoeuvreTMLength( shortTm, &ao, &dummyManoeuvre))
	{	setTestResult(TEST_FAILURE, "Manoeuvre test 1 failed");
		return;
	}

    if (!testManoeuvreTMLength( normalTm, &ao, &dummyManoeuvre))
	{	setTestResult(TEST_FAILURE, "Manoeuvre test 1 failed");
		return;
	}

    if (!testManoeuvreTMLength( longTm, &ao, &dummyManoeuvre))
	{	setTestResult(TEST_FAILURE, "Manoeuvre test 1 failed");
		return;
	}

    if (!testManoeuvreTMLength( debugTm, &ao, &dummyManoeuvre))
	{	setTestResult(TEST_FAILURE, "Manoeuvre test 1 failed");
		return;
	}

    AocsEvent aoe;
    ManoeuvreEvent me;

    if (!testManoeuvreEventTMLength( shortTm, &aoe, &me))
	{	setTestResult(TEST_FAILURE, "Manoeuvre test 1 failed");
		return;
	}

    if (!testManoeuvreEventTMLength( normalTm, &aoe, &me))
	{	setTestResult(TEST_FAILURE, "Manoeuvre test 1 failed");
		return;
	}

    if (!testManoeuvreEventTMLength( longTm, &aoe, &me))
	{	setTestResult(TEST_FAILURE, "Manoeuvre test 1 failed");
		return;
	}

    if (!testManoeuvreEventTMLength( debugTm, &aoe, &me))
	{	setTestResult(TEST_FAILURE, "Manoeuvre test 1 failed");
		return;
	}

	// If this point is reached, test was successful
	setTestResult(TEST_SUCCESS,NULL);
	return;
}


