// CyclingModeManager.cpp
//
// Version	1.0
// Date		04.04.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#include "../ModeManagement/CyclingModeManager.h"
#include "../ModeManagement/ModeManager.h"
#include "../GeneralInclude/ClassId.h"

// -------------------------------------------------------------------

CyclingModeManager::CyclingModeManager(int m,int d,int n):ModeManager(m,1,d,n)
{
	setClassId(ID_CYCLINGMODEMANAGER);		// assign class identifier

}

// -------------------------------------------------------------------
// The cycling mode manager cycles through all the modes

void CyclingModeManager::updateMode()
{
	int temp;
	if (currentMode==(nModes-1))
		changeMode(0);
	else
	{	temp=currentMode+1;
		changeMode(temp);
	}
}

// -------------------------------------------------------------------
// Return the strategy corresponding to the current mode 

RootObject* CyclingModeManager::getImplementer(int strategy)
{
	RootObject* temp=ModeManager::getImplementer(strategy);
	updateMode();
	return temp;
}

