// FollowerModeManager.cpp
//
// Version	1.0
// Date		04.04.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#include "../ModeManagement/FollowerModeManager.h"
#include "../ModeManagement/ModeManager.h"
#include "../GeneralInclude/ClassId.h"
#include "../ObjectMonitoring/SimpleChange.h"
#include "../ObjectMonitoring/PropertyMonitor.h"

// -------------------------------------------------------------------

FollowerModeManager::FollowerModeManager(int nOfModes,int nOfStrat,
									 int nOfMon, ModeManager* master):
	ModeManager(nOfModes,nOfStrat,
						(int)master->getModeProperty().get(),nOfMon)
{
	setClassId(ID_FOLLOWERMODEMANAGER);		// assign class identifier

	masterModeManager = master;
		
	// Link up to the master mode manager
	masterModeManager->addMonitor(this,&simpleChange);

	// Initialize the mode of the follower to the same mode as the master
//	changeMode((int)(masterModeManager->getModeProperty().get()));

	// Initialize the change object
	simpleChange.setReferenceValue(masterModeManager->getModeProperty().get());
}

// -------------------------------------------------------------------

void FollowerModeManager::propertyChange(AocsObject* changeOriginator,
										   Property monitoredProperty,
											 ChangeObject* changeObject)
{
	changeMode((int)(monitoredProperty.get()));
}
