// ModeChangeAction.cpp
//
// Version	1.0
// Date		18.09.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#include "../ModeManagement/ModeChangeAction.h"
#include "../GeneralInclude/Constants.h"
#include "../GeneralInclude/ClassId.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../GeneralInclude/ForwardDeclarations.h"
#include "../BasicObjects/AocsObject.h"

// -------------------------------------------------------------------
// Define static variables
int ModeChangeAction::tmImageLength[NTMFORMATS];

// -------------------------------------------------------------------

ModeChangeAction::ModeChangeAction()
{
	setClassId(ID_MODECHANGEACTION);				

	tmImageLength[shortTm]  = 0;	// Not implemented in prototype f/w	
	tmImageLength[normalTm] = 0;
	tmImageLength[longTm]   = 0;
	tmImageLength[debugTm]  = 0;

	localResetConfiguration();
}

// -------------------------------------------------------------------

void ModeChangeAction::doModeExitAction(int oldMode)
{	
	if (nextModeChangeAction!=NULL)
		nextModeChangeAction->doModeExitAction(oldMode);
}

// -------------------------------------------------------------------

void ModeChangeAction::doModeEntryAction(int newMode)
{	
	if (nextModeChangeAction!=NULL)
		nextModeChangeAction->doModeEntryAction(newMode);
}

// -------------------------------------------------------------------

void ModeChangeAction::localResetConfiguration()
{
	nextModeChangeAction = NULL;
}

// -------------------------------------------------------------------
// From Configurable interface

void ModeChangeAction::resetConfiguration()
{
	AocsObject::resetConfiguration();
	localResetConfiguration();
}

// -------------------------------------------------------------------
// From Telemeterable interface

int ModeChangeAction::getTelemetryImageLength()
{
	return (tmImageLength[getTelemetryFormat()]
								+AocsObject::getTelemetryImageLength());
}

// -------------------------------------------------------------------
// From Telemeterable interface

void ModeChangeAction::writeToTelemetry(TelemetryStream* tmStream)
{
	AocsObject::writeToTelemetry(tmStream);		// write super object's state

	// TBD : not implemented in framework prototype
}

