// ModeChangeAction.h 
//
// Version	1.0
// Date		18.09.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
//
// Base class for Mode Change Objects.
// The chain of responsibility pattern is used to link together
// several mode change actions.
//
// -------------------------------------------------------------------

#ifndef ModeChangeActionH
#define ModeChangeActionH

// -------------------------------------------------------------------

#include "../GeneralInclude/ForwardDeclarations.h"
#include "../BasicObjects/AocsObject.h"

// -------------------------------------------------------------------

class ModeChangeAction : public AocsObject {

	ModeChangeAction* nextModeChangeAction;
	static int tmImageLength[NTMFORMATS];

	// Local reset method
	void localResetConfiguration();		

public :

	ModeChangeAction();

	virtual void doModeExitAction(int oldMode);
	virtual void doModeEntryAction(int newMode);

	// Methods inherited from interface Configurable
	virtual void resetConfiguration();		

	// Methods inherited from interface Telemeterable
	virtual void writeToTelemetry(TelemetryStream* stream);
	virtual int getTelemetryImageLength();

	void setNextModeChangeAction(ModeChangeAction* n)
		{ nextModeChangeAction = n;}
	ModeChangeAction* getNextModeChangeAction()
		{ return nextModeChangeAction;}		
};

// -------------------------------------------------------------------
#endif