// ModeManagementTest.cpp 
//
// Version	1.0
// Date		28.01.01
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Test program for the mode management framelet
// -------------------------------------------------------------------

// Include system header files
#include <stdio.h>

#include "../../GeneralUtilities/TestSuite.h"
#include "../../GeneralUtilities/TestUtilities.h"
#include "../../GeneralInclude/CompilerSwitches.h"
#include "TestCaseModeManagement_1.h"
#include "TestCaseModeManagement_2.h"
#include "TestCaseModeManagement_3.h"
#include "TestCaseModeManagement_4.h"

// -------------------------------------------------------------------

int main(int argc, char* argv[])
{
	// Open output file (only on MS_HOST)
	FILE* out=NULL;
#ifdef MS_HOST
    if( (out  = fopen("ModeManagementTestOut.txt","w")) == NULL )
      printf( "\nThe file 'ModeManagementTestOut' could not be opened\n" );   
	else
      printf( "\nThe file 'ModeManagementTestOut' was successfully opened\n" );
#endif

    printf( "\nBegin test for the mode management framelet ...\n" );
	printTestHeader(out, "ModeManagementTest");

	// Create test cases 
	TestCaseModeManagement_1 testCase_1;
	TestCaseModeManagement_2 testCase_2;
	TestCaseModeManagement_3 testCase_3;
	TestCaseModeManagement_4 testCase_4;

	// Create and load a test suite
	TestSuite testSuite(out);
	testSuite.loadTestCase(&testCase_1);
	testSuite.loadTestCase(&testCase_2);
	testSuite.loadTestCase(&testCase_3);
	testSuite.loadTestCase(&testCase_4);

	// Run the test suite -- this causes all test cases in
	// the test suite to be run in sequence
	testSuite.runTestSuite();

    printf( "\nTest for the mode management framelet ended...\n" );

	// close output file
#ifdef MS_HOST
	fclose(out); 
#endif
	return 0;
}