// NullModeChangeAction.h 
//
// Version	1.0
// Date		18.09.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
//
// Null mode change action: its mode exit and mode entry methods 
// do nothing and return.
// This class is useful to fill the mode change action plug-in in
// mode managers that do not need to perform any action upon mode
// changes.
//
// -------------------------------------------------------------------

#ifndef NullModeChangeActionH
#define NullModeChangeActionH

// -------------------------------------------------------------------

#include "../ModeManagement/ModeChangeAction.h"
#include "../GeneralInclude/ClassId.h"

// -------------------------------------------------------------------

class NullModeChangeAction : public ModeChangeAction {


public :

	NullModeChangeAction()
		{ setClassId(ID_NULLMODECHANGEACTION); }

	virtual void doModeExitAction(int oldMode)
		{ ModeChangeAction::doModeExitAction(oldMode); }

	virtual void doModeEntryAction(int newMode)
		{ ModeChangeAction::doModeEntryAction(newMode); }

};

// -------------------------------------------------------------------
#endif