// ObjectListTest.cpp 
//
// Version	1.0
// Date		07.01.01
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Test program for object lists
// -------------------------------------------------------------------

// Include system header files
#include <stdio.h>

#include "../../GeneralUtilities/TestSuite.h"
#include "../../GeneralUtilities/TestUtilities.h"
#include "../../GeneralInclude/CompilerSwitches.h"
#include "TestCaseObjectList_1.h"
#include "TestCaseObjectList_2.h"
#include "TestCaseObjectList_3.h"

// -------------------------------------------------------------------

int main(int argc, char* argv[])
{
	// Open output file (only on MS_HOST)
	FILE* out=NULL;
#ifdef MS_HOST
    if( (out  = fopen("ObjectListOut.txt","w")) == NULL )
      printf( "\nThe file 'ObjectListOut' could not be opened\n" );   
	else
      printf( "\nThe file 'ObjectListOut' was successfully opened\n" );
#endif

    printf( "\nBegin test for ObjectList class ...\n" );
	printTestHeader(out,"ObjectListTest");

	// Create test cases for class AocsObject
	TestCaseObjectList_1 testCase_1;
	TestCaseObjectList_2 testCase_2;
	TestCaseObjectList_3 testCase_3;

	// Create and load a test suite
	TestSuite testSuite(out);
	testSuite.loadTestCase(&testCase_1);
	testSuite.loadTestCase(&testCase_2);
	testSuite.loadTestCase(&testCase_3);

	// Run the test suite -- this causes all test cases in
	// the test suite to be run in sequence
	testSuite.runTestSuite();

    printf( "\nTest for ObjectList class ended...\n" );

	// close output file
#ifdef MS_HOST
	fclose(out); 
#endif
	return 0;
}