// ObjectListTestSuite.h 
//
// Version	1.0
// Date		18.02.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Test suite for object lists
// -------------------------------------------------------------------

// Perform tests for the object list and write results to outFile
void objectListTestMaster(FILE* outFile);

// Check configuration operations on an object list.
// Argument 1: object list to be checked (assumed not yet configured)
// Argument 2: size to be assigned to object list
bool objectListTest_1(ObjectListTemplate<AocsObject>* list, int size);

// Check add and remove operations on an object list.
// Argument 1: object list to be checked (assumed to have size greater than 4)
bool objectListTest_2(ObjectListTemplate<AocsObject>* list);

// Check iteration operations on an object list.
// Argument 1: object list to be checked (assumed configured and with size
//			   greater than 3)
bool objectListTest_3(ObjectListTemplate<AocsObject>* list);
