// TestCaseObjectList.cpp
//
// Version	1.0
// Date		06.01.01
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#include "TestCaseObjectList.h"
#include "../../GeneralInclude/ClassId.h"
#include "../../GeneralInclude/Constants.h"
#include "../../AocsEvent/FailureEventRepository.h"
#include "../../AocsEvent/ConfigurationEventRepository.h"
#include "../../BasicObjects/AocsObject.h"

// -------------------------------------------------------------------

bool TestCaseObjectList::setUpTestCase() {

	// Allocate memory to event repositories
	size = 4;
	failureEvtRep.setRepositorySize(size);	
	configEvtRep.setRepositorySize(size);	

	// allocate memory for object list
	objectList.allocateMemory(size);

	// Advance dummy AOCS clock by two cycles
	aocsClock.run(0);
	aocsClock.run(0);

	// Configure the static part of AocsObject 
	AocsObject::setAocsClock(&aocsClock);
	AocsObject::setFailureEventRepository(&failureEvtRep);		
	AocsObject::setConfigurationEventRepository(&configEvtRep);
	AocsObject::setDestructionRecoveryAction(&nullRecAct);

	return INITIALIZATION_SUCCESS;
}
