// TestCaseObjectList.h
//
// Version	1.0
// Date		07.01.01
// Author	A. Pasetti
//
// -------------------------------------------------------------------
//
// Abstract base class for test cases for classes ObjectList.
//
// -------------------------------------------------------------------

#ifndef TestCaseObjectListH
#define TestCaseObjectListH

#include "../../GeneralUtilities/TestCase.h"
#include "../../AocsEvent/FailureEventRepository.h"
#include "../../AocsEvent/ConfigurationEventRepository.h"
#include "../../ObjectList/ObjectListTemplate.h"
#include "../../OperatingSystemObjects/DummyAocsClock.h"
#include "../../FailureRecovery/NullRecoveryAction.h"

// -------------------------------------------------------------------

class TestCaseObjectList : public TestCase {

protected :

	FailureEventRepository failureEvtRep;
	ConfigurationEventRepository configEvtRep;

	DummyAocsClock aocsClock;

	NullRecoveryAction nullRecAct;

	ObjectListTemplate<AocsObject> objectList;
	int size;

public :

	TestCaseObjectList(int testId, char* testName):
	   TestCase(testId,testName)
	   { return; }

	virtual bool setUpTestCase();

	virtual void runTestCase()
		{ return; }
	
	virtual bool shutDownTestCase()
		{ return SHUTDOWN_SUCCESS; }

};

// -------------------------------------------------------------------

#endif