// DeltaChange.h 
//
// Version	1.0
// Date		29.03.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
//
// Encapsulation of a delta change (the change occurs if the test value
// differs from the previous value by more than the reference value)
//
// -------------------------------------------------------------------

#ifndef DeltaChangeH
#define DeltaChangeH

// -------------------------------------------------------------------

#include "../ObjectMonitoring/ChangeObject.h"
#include "../GeneralInclude/ForwardDeclarations.h"
#include "../GeneralInclude/Constants.h"
#include "../GeneralInclude/BasicTypes.h"

// -------------------------------------------------------------------

class DeltaChange : public ChangeObject {

	static int tmImageLength[NTMFORMATS];

	Real oldValue;
	bool firstCheck;

	void localReset();

public :

	DeltaChange(Real referenceValue);
	virtual bool checkValue(Real value);

	virtual void writeToTelemetry(TelemetryStream* stream);
	virtual int getTelemetryImageLength();

	// Method inherited from Resettable interface
	virtual void reset();
};

// -------------------------------------------------------------------
#endif