// ObjectMonitoring.cpp 
//
// Version	1.0
// Date		22.01.01
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Test program for the object monitoring framelet
// -------------------------------------------------------------------

// Include system header files
#include <stdio.h>

#include "../../GeneralUtilities/TestSuite.h"
#include "../../GeneralUtilities/TestUtilities.h"
#include "../../GeneralInclude/CompilerSwitches.h"
#include "TestCaseObjectMonitoring_1.h"
#include "TestCaseObjectMonitoring_2.h"

// -------------------------------------------------------------------

int main(int argc, char* argv[])
{
	// Open output file (only on MS_HOST)
	FILE* out=NULL;
#ifdef MS_HOST
    if( (out  = fopen("ObjectMonitoringOut.txt","w")) == NULL )
      printf( "\nThe file 'ObjectMonitoringOut' could not be opened\n" );   
	else
      printf( "\nThe file 'ObjectMonitoringOut' was successfully opened\n" );
#endif

    printf( "\nBegin test for ObjectMonitoring framelet ...\n" );
	printTestHeader(out, "ObjectMonitoringTest");

	// Create test cases for class AocsObject
	TestCaseObjectMonitoring_1 testCase_1;
	TestCaseObjectMonitoring_2 testCase_2;

	// Create and load a test suite
	TestSuite testSuite(out);
	testSuite.loadTestCase(&testCase_1);
	testSuite.loadTestCase(&testCase_2);

	// Run the test suite -- this causes all test cases in
	// the test suite to be run in sequence
	testSuite.runTestSuite();

    printf( "\nTest for ObjectMonitoring framelet ended...\n" );

	// close output file
#ifdef MS_HOST
	fclose(out); 
#endif
	return 0;
}