// TestCaseObjectMonitoring_2.cpp
//
// Version	1.0
// Date		23.01.01
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#include "TestCaseObjectMonitoring_2.h"
#include "../../GeneralInclude/ClassId.h"
#include "../../GeneralInclude/Constants.h"
#include "../../ObjectMonitoring/Property.h"
#include "../../ObjectMonitoring/PropertyId.h"

// -------------------------------------------------------------------
TestCaseObjectMonitoring_2::TestCaseObjectMonitoring_2():
	TestCaseGenericSetUp(ID_SIMPLECHANGE*10+2,"TestCaseObjectMonitoring_2") {
		return;
}

// -------------------------------------------------------------------

void TestCaseObjectMonitoring_2::runTestCase() {

	// Create dummy data
	Real datum=10.0;
	int intDatum=3;

	// Create property objects with real argument
	Property property(&datum, DUMMY_PROPERTY);

	// Check property methods
	if ( (property.get()!=datum) )
	{	setTestResult(TEST_FAILURE, "Incorrect property value");
		return;
	}

	if (property.getPropertyId()!=DUMMY_PROPERTY)
	{	setTestResult(TEST_FAILURE, "Incorrect property ID");
		return;
	}

	// Create property objects with int argument
	Property intProperty(&intDatum, DUMMY_PROPERTY);

	// Check property methods
	if ( (intProperty.get()!=intDatum) )
	{	setTestResult(TEST_FAILURE, "Incorrect property value");
		return;
	}

	// If this point is reached, test was successful
	setTestResult(TEST_SUCCESS,NULL);
	return;
}
