// OutOfRangeChange.h 
//
// Version	1.0
// Date		29.03.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
//
// Encapsulation of a delta change (the change occurs if the test value
// lies outside the range [lowerBound, referenceValue])
//
// -------------------------------------------------------------------

#ifndef OutOfRangeChangeH
#define OutOfRangeChangeH

// -------------------------------------------------------------------

#include "../GeneralInclude/Constants.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../GeneralInclude/Constants.h"
#include "../ObjectMonitoring/ChangeObject.h"

// -------------------------------------------------------------------

class OutOfRangeChange : public ChangeObject {

	static int tmImageLength[NTMFORMATS];
	Real lowerBound;
	Real upperBound;

public :

	OutOfRangeChange(Real lowerBound, Real higherBound);
	virtual bool checkValue(Real value);

	virtual void writeToTelemetry(TelemetryStream* stream);
	virtual int getTelemetryImageLength();

};

// -------------------------------------------------------------------
#endif