// PropertyMonitor.h
//
// Version	1.0
// Date		30.03.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Interface class to be implemented by objects acting as property 
// monitor.
// Method propertyChange is a call-back method triggered when the
// monitored property undergoes the change encapsulated in 
// ChangeObject
// -------------------------------------------------------------------

#ifndef PropertyMonitorH
#define PropertyMonitorH

// -------------------------------------------------------------------

#include "../GeneralInclude/ForwardDeclarations.h"
#include "../ObjectMonitoring/Property.h"

// -------------------------------------------------------------------

class PropertyMonitor {

public:

	virtual void propertyChange(AocsObject* changeOriginator,
								  Property monitoredProperty,
									ChangeObject* changeObject)=0;
};

// -------------------------------------------------------------------
#endif