// SimpleChange.cpp
//
// Version	1.0
// Date		29.03.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#include "../ObjectMonitoring/SimpleChange.h"
#include "../GeneralInclude/ForwardDeclarations.h"
#include "../GeneralInclude/Constants.h"
#include "../GeneralInclude/ClassId.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../BasicObjects/AocsObject.h"


// -------------------------------------------------------------------
// Define static variables
int SimpleChange::tmImageLength[NTMFORMATS];

// -------------------------------------------------------------------

SimpleChange::SimpleChange()
{
	setClassId(ID_SIMPLECHANGE);			

	tmImageLength[shortTm]  = 0;	
	tmImageLength[normalTm] = sizeof(Real);
	tmImageLength[longTm]   = tmImageLength[normalTm] ;
	tmImageLength[debugTm]  = tmImageLength[normalTm] ;

	referenceValue = 0;

}

// -------------------------------------------------------------------

SimpleChange::SimpleChange(Real r)
{
	setClassId(ID_SIMPLECHANGE);			

	tmImageLength[shortTm]  = 0;	
	tmImageLength[normalTm] = sizeof(Real);
	tmImageLength[longTm]   = tmImageLength[normalTm] ;
	tmImageLength[debugTm]  = tmImageLength[normalTm] ;

	referenceValue = r;

}

// -------------------------------------------------------------------

bool SimpleChange::checkValue(Real value)
{
	if (value!=referenceValue)
	{	referenceValue = value;
		return true;
	}
	referenceValue = value;
	return false;	
}

// -------------------------------------------------------------------
// From Telemeterable interface

int SimpleChange::getTelemetryImageLength()
{
	return (tmImageLength[getTelemetryFormat()]
								+AocsObject::getTelemetryImageLength());
}

// -------------------------------------------------------------------
// From Telemeterable interface

void SimpleChange::writeToTelemetry(TelemetryStream* tmStream)
{
	AocsObject::writeToTelemetry(tmStream);		// write super object's state

	// TBD : not implemented in framework prototype
}