// SimpleChange.h 
//
// Version	1.0
// Date		29.03.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
//
// Encapsulation of a simple change (the change occurs if the last value
// is different from the previous value)
//
// -------------------------------------------------------------------

#ifndef SimpleChangeH
#define SimpleChangeH

// -------------------------------------------------------------------

#include "../GeneralInclude/Constants.h"
#include "../GeneralInclude/ForwardDeclarations.h"
#include "../ObjectMonitoring/ChangeObject.h"

// -------------------------------------------------------------------

class SimpleChange : public ChangeObject {

	static int tmImageLength[NTMFORMATS];

public :

	SimpleChange();
	void initialize(Real r)
		{ referenceValue = r; }

	SimpleChange(Real referenceValue);

	virtual bool checkValue(Real value);

	virtual void writeToTelemetry(TelemetryStream* stream);
	virtual int getTelemetryImageLength();
};

// -------------------------------------------------------------------
#endif