// DummyAocsClock.h
//
// Version	1.1
// Date		18.01.00
// Author	A. Pasetti/T. Brown
//
// -------------------------------------------------------------------
// Dummy implementation of AocsClock interface. 
// Every call to run() advances the clock's time by 'dummyPeriod'
// -------------------------------------------------------------------

#ifndef DummyAocsClockH
#define DummyAocsClockH

#define dummyPeriod 10

#include "../GeneralInclude/Constants.h"
#include "../GeneralInclude/ClassId.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../GeneralInclude/ForwardDeclarations.h"
#include "../BasicObjects/AocsObject.h"
#include "../OperatingSystemObjects/Runnable.h"
#include "../OperatingSystemObjects/AocsClock.h"

// -------------------------------------------------------------------

class DummyAocsClock : public AocsObject, public Runnable, public AocsClock {

	AocsTime  currentTime;
	AocsCycle currentCycle;
	static ClassId classId;
	static int tmImageLength[NTMFORMATS];

	void localReset();

public :

	DummyAocsClock();

	int getClockPeriod()
		{ return dummyPeriod; }

	virtual AocsTime getTime();				// from AocsClock
	virtual AocsCycle getCycle();
	virtual void synchronizeWithSystemTime();

	virtual void reset();					// from Resettable through AocsObject

	virtual int getTelemetryImageLength();	// from Telemeterable through AocsObject
	virtual void writeToTelemetry(TelemetryStream* stream);

	virtual void run(AocsTime deadline);	// from Runnable

};

// -------------------------------------------------------------------
#endif