// Runnable.h
//
// Version	1.0
// Date		14.01.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// This is an interface class.
//
// Default implementations are provided for initialize and terminate 
// since in most case active objects do not perform any actions upon
// initialization or termination.
// -------------------------------------------------------------------

#ifndef RunnableH
#define RunnableH

// -------------------------------------------------------------------

#include "../GeneralInclude/BasicTypes.h"

// -------------------------------------------------------------------

class Runnable {

public:

	virtual void run(AocsTime deadline)=0;

	virtual bool initialize()
		{ return true; }

	virtual bool terminate()
		{ return true; }
};

// -------------------------------------------------------------------
#endif