// ConfigurationState.h
//
// Version	1.0
// Date		13.04.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Class to store the configuration state of a configuration manager
//
// -------------------------------------------------------------------

#ifndef ConfigurationStateH
#define ConfigurationStateH

// -------------------------------------------------------------------

#include "../GeneralInclude/ForwardDeclarations.h"
#include "../GeneralInclude/BasicTypes.h"
#include "../GeneralInclude/Constants.h"
#include "../BasicObjects/RootObject.h"

// -------------------------------------------------------------------

class ConfigurationState : public RootObject {

	InstanceId reconfigurationManagerId;

	int memoryPad;

public :

	ConfigurationState();

	ConfigurationState(InstanceId reconfigurationManagerId, int memoryPad);

	InstanceId getReconfigurationManagerId()
		{ return reconfigurationManagerId; }

	int getMemoryPad()
		{ return memoryPad; }

};

// -------------------------------------------------------------------
#endif