// ReconfigurationManagementTest.cpp 
//
// Version	1.0
// Date		04.04.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Test program for the reconfiguration management framelet
// -------------------------------------------------------------------

// Include system header files
#include <stdio.h>

#include "../../GeneralUtilities/TestSuite.h"
#include "../../GeneralUtilities/TestUtilities.h"
#include "../../GeneralInclude/CompilerSwitches.h"
#include "TestCaseReconfiguration_1.h"
#include "TestCaseReconfiguration_2.h"
#include "TestCaseReconfiguration_3.h"
#include "TestCaseReconfiguration_4.h"

// -------------------------------------------------------------------

int main(int argc, char* argv[])
{
	// Open output file (only on MS_HOST)
	FILE* out=NULL;
#ifdef MS_HOST
    if( (out  = fopen("ReconfigurationManagementTestOut.txt","w")) == NULL )
      printf( "\nThe file 'ReconfigurationManagementTestOut' could not be opened\n" );   
	else
      printf( "\nThe file 'ReconfigurationManagementTestOut' was successfully opened\n" );
#endif

    printf( "\nBegin test for the reconfiguration management framelet ...\n" );
	printTestHeader(out, "ReconfigurationManagementTest");

	// Create test cases 
	TestCaseReconfiguration_1 testCase_1;
	TestCaseReconfiguration_2 testCase_2;
	TestCaseReconfiguration_3 testCase_3;
	TestCaseReconfiguration_4 testCase_4;

	// Create and load a test suite
	TestSuite testSuite(out);
	testSuite.loadTestCase(&testCase_1);
	testSuite.loadTestCase(&testCase_2);
	testSuite.loadTestCase(&testCase_3);
	testSuite.loadTestCase(&testCase_4);

	// Run the test suite -- this causes all test cases in
	// the test suite to be run in sequence
	testSuite.runTestSuite();

    printf( "\nTest for the reconfiguration framelet ended...\n" );

	// close output file
#ifdef MS_HOST
	fclose(out); 
#endif
	return 0;
}