// AdderBlock.h
//
// Version	1.0
// Date		13.10.00
// Author	T. Brown
//
// Change History:
//
// -------------------------------------------------------------------
// Control block to implement a simple adder output.
//
// The block implements the following multi-input-single-output transfer
// function: y = u0 + u1
//
// -------------------------------------------------------------------

#ifndef AdderBlockH
#define AdderBlockH

// -------------------------------------------------------------------

#include "../SequentialDataProcessing/ControlChannelBlock.h"
#include "../GeneralInclude/Constants.h"
#include "../GeneralInclude/BasicTypes.h"

// -------------------------------------------------------------------

class AdderBlock : public ControlChannelBlock {

	static ClassId classId;
	static int tmImageLength[NTMFORMATS];

	virtual void propagationAlgorithm(AocsTime t);

	void localResetConfiguration();

public :

	AdderBlock();

	virtual void resetConfiguration();

	virtual int getTelemetryImageLength();
	virtual void writeToTelemetry(TelemetryStream* stream);
};

#endif // AdderBlockH
