// DifferenceBlock.h
//
// Version	1.0
// Date		13.10.00
// Author	T. Brown
//
// Change History:
//
// -------------------------------------------------------------------
// Control block to implement a simple difference output.
//
// The block implements the following multi-input-single-output transfer
// function: y = u1 - u0
//
// -------------------------------------------------------------------

#ifndef DifferenceBlockH
#define DifferenceBlockH

// -------------------------------------------------------------------

#include "../SequentialDataProcessing/ControlChannelBlock.h"
#include "../GeneralInclude/Constants.h"
#include "../GeneralInclude/BasicTypes.h"

// -------------------------------------------------------------------

class DifferenceBlock : public ControlChannelBlock {

	static ClassId classId;
	static int tmImageLength[NTMFORMATS];

	virtual void propagationAlgorithm(AocsTime t);

	void localResetConfiguration();

public :

	DifferenceBlock();

	virtual void resetConfiguration();

	virtual int getTelemetryImageLength();
	virtual void writeToTelemetry(TelemetryStream* stream);
};

#endif // DifferenceBlockH
