// P_Block.h
//
// Version	1.0
// Date		18.02.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Control block to implement a pure gain.
//
// The block implements the following single-input-single-output transfer
// function: y = gain*u
//
// -------------------------------------------------------------------

#ifndef P_BlockH
#define P_BlockH

// -------------------------------------------------------------------

#include "../SequentialDataProcessing/ControlChannelBlock.h"
#include "../GeneralInclude/Constants.h"
#include "../GeneralInclude/BasicTypes.h"

// -------------------------------------------------------------------

class P_Block : public ControlChannelBlock {

	static int tmImageLength[NTMFORMATS];

	Real gain;

	virtual void propagationAlgorithm(AocsTime t);
	
	void localResetConfiguration();

public :

	P_Block();

	void setGain(Real newGain)
		{ gain = newGain; }

	virtual void resetConfiguration();

	virtual int getTelemetryImageLength();
	virtual void writeToTelemetry(TelemetryStream* stream);
};

#endif
