// PassThruBlock.cpp
//
// Version	1.0
// Date	13.10.00
// Author	T. Brown
//
// Change History:
//
// -------------------------------------------------------------------

// Include framework header files
#include "../SequentialDataProcessing/PassThruBlock.h"
#include "../GeneralInclude/ClassId.h"
#include "../GeneralInclude/Constants.h"

int PassThruBlock::tmImageLength[NTMFORMATS] = {0, 0, 0, 0};

// -------------------------------------------------------------------
// Default constructor.
PassThruBlock::PassThruBlock()
{
	setClassId(ID_PASSTHRUBLOCK);		// assign class identifier

	allocateMemory(1,1,0);				// 1 input, 1 output, 0 states

	localResetConfiguration();
}

// -------------------------------------------------------------------

void PassThruBlock::propagationAlgorithm(AocsTime t)
{
	output[0] = input[0];
}

// -------------------------------------------------------------------

void PassThruBlock::writeToTelemetry(TelemetryStream* stream)
{
	// write super object's state
	ControlChannelBlock::writeToTelemetry(stream);

	// TBD - not done in prototype
}

// -------------------------------------------------------------------

int PassThruBlock::getTelemetryImageLength()
{
	return (tmImageLength[getTelemetryFormat()]+
			ControlChannelBlock::getTelemetryImageLength());
}
