// RawBusDataConverterIn.cpp
//
// Version	1.0
// Date		30.05.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------

// Include framework header files
#include "../GeneralInclude/BasicTypes.h"
#include "../GeneralInclude/ClassId.h"
#include "../SequentialDataProcessing/RawBusDataConverterIn.h"

// -------------------------------------------------------------------

RawBusDataConverterIn::RawBusDataConverterIn(int m, Real r)				
{
	setClassId(ID_RAWBUSDATACONVERTERIN);				

	resolutionLevel = r;
	numberOfChannels = m;

	allocateMemory(m,m,0);					// m inputs, m outputs, 0 states
					
}

// -------------------------------------------------------------------

void RawBusDataConverterIn::propagationAlgorithm(AocsTime t)
{
	unsigned short* rawDatum;
	unsigned short mask = 0x8000;

	for (int i=0; i<numberOfChannels; i++)
	{	rawDatum = (unsigned short*)&input[i];
		output[i] = ( (*rawDatum) & 0x7FFF) * resolutionLevel;
		if ( ((*rawDatum) & mask)==0 )
			output[i] = -output[i];
	}
}

