// ControlChannelTest.cpp 
//
// Version	1.0
// Date		27.01.01
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Test program for the control channel classes
// -------------------------------------------------------------------

// Include system header files
#include <stdio.h>

#include "../../GeneralUtilities/TestSuite.h"
#include "../../GeneralUtilities/TestUtilities.h"
#include "../../GeneralInclude/CompilerSwitches.h"
#include "TestCaseControlChannel_1.h"
#include "TestCaseControlChannel_2.h"
#include "TestCaseControlChannel_3.h"
#include "TestCaseControlChannel_4.h"
#include "TestCaseControlChannel_5.h"
#include "TestCaseControlChannel_6.h"
#include "TestCaseControlChannel_7.h"
#include "TestCaseControlChannel_8.h"
#include "TestCaseXmathUcbBlock_1.h"
#include "TestCaseXmathUcbBlock_2.h"
#include "TestCaseXmathUcbBlock_3.h"

// -------------------------------------------------------------------

int main(int argc, char* argv[])
{
	// Open output file (only on MS_HOST)
	FILE* out=NULL;
#ifdef MS_HOST
    if( (out  = fopen("ControlChannelTestOut.txt","w")) == NULL )
      printf( "\nThe file 'ControlChannelTestOut' could not be opened\n" );   
	else
      printf( "\nThe file 'ControlChannelTestOut' was successfully opened\n" );
#endif

    printf( "\nBegin test for control channel classes ...\n" );
	printTestHeader(out, "ControlChannelTest");

	// Create test cases 
	TestCaseControlChannel_1 testCase_1;
	TestCaseControlChannel_2 testCase_2;
	TestCaseControlChannel_3 testCase_3;
	TestCaseControlChannel_4 testCase_4;
	TestCaseControlChannel_5 testCase_5;
	TestCaseControlChannel_6 testCase_6;
	TestCaseControlChannel_7 testCase_7;
	TestCaseControlChannel_8 testCase_8;
	TestCaseXmathUcbBlock_1 testCase_9;
	TestCaseXmathUcbBlock_2 testCase_10;
	TestCaseXmathUcbBlock_3 testCase_11;

	// Create and load a test suite
	TestSuite testSuite(out);
	testSuite.loadTestCase(&testCase_1);
	testSuite.loadTestCase(&testCase_2);
	testSuite.loadTestCase(&testCase_3);
	testSuite.loadTestCase(&testCase_4);
	testSuite.loadTestCase(&testCase_5);
	testSuite.loadTestCase(&testCase_6);
	testSuite.loadTestCase(&testCase_7);
	testSuite.loadTestCase(&testCase_8);
	testSuite.loadTestCase(&testCase_9);
	testSuite.loadTestCase(&testCase_10);
	testSuite.loadTestCase(&testCase_11);

	// Run the test suite -- this causes all test cases in
	// the test suite to be run in sequence
	testSuite.runTestSuite();

    printf( "\nTest for control channel classes ended...\n" );

	// close output file
#ifdef MS_HOST
	fclose(out); 
#endif
	return 0;
}