// DummyBlock_Double.h
//
// Version	1.0
// Date		18.02.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Dummy control block used for testing purposes.
//
// The block implements the following single-input-single-output transfer
// function: y = 2*u
//
// -------------------------------------------------------------------

#ifndef DummyBlock_DoubleH
#define DummyBlock_DoubleH

// -------------------------------------------------------------------

class DummyBlock_Double : public ControlChannelBlock {

	static ClassId classId;
	static int tmImageLength[NTMFORMATS];

	virtual void propagationAlgorithm(AocsTime t);

protected :

	virtual void setTmImageLength(TelemetryFormat fmt, int v)
		{ tmImageLength[fmt] = v; }
	virtual int getLocalTelemetryImageLength(TelemetryFormat fmt)
		{ return tmImageLength[fmt]; }

public :

	DummyBlock_Double();

};

#endif
