// SplitterBlock.cpp
//
// Version	1.0
// Date	17.11.00
// Author	A. Pasetti
//
// Change History:
//
// -------------------------------------------------------------------

// Include framework header files
#include "../SequentialDataProcessing/SplitterBlock.h"
#include "../GeneralInclude/ClassId.h"
#include "../GeneralInclude/Constants.h"

int SplitterBlock::tmImageLength[NTMFORMATS] = {0, 0, 0, 0};

// -------------------------------------------------------------------
// Default constructor.
SplitterBlock::SplitterBlock(int n)
{
	setClassId(ID_SPLITTERBLOCK);		// assign class identifier

	allocateMemory(1,n,0);				// 1 input, n outputs, 0 states

	localResetConfiguration();
}

// -------------------------------------------------------------------

void SplitterBlock::propagationAlgorithm(AocsTime t)
{
	for (int i=0; i<getOutputOrder(); i++)
		output[i] = input[0];
}


// -------------------------------------------------------------------

void SplitterBlock::writeToTelemetry(TelemetryStream* stream)
{
	// write super object's state
	ControlChannelBlock::writeToTelemetry(stream);

	// TBD - not done in prototype
}

// -------------------------------------------------------------------

int SplitterBlock::getTelemetryImageLength()
{
	return (tmImageLength[getTelemetryFormat()]+
			ControlChannelBlock::getTelemetryImageLength());
}


