// TwoByTwoMatrixBlock.h
//
// Version	1.0
// Date		18.02.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Control block to implement 2x2 matrix.
//
// -------------------------------------------------------------------

#ifndef TwoByTwoMatrixBlockH
#define TwoByTwoMatrixBlockH

// -------------------------------------------------------------------

#include "../SequentialDataProcessing/ControlChannelBlock.h"
#include "../GeneralInclude/Constants.h"
#include "../GeneralInclude/BasicTypes.h"

// -------------------------------------------------------------------

class TwoByTwoMatrixBlock : public ControlChannelBlock {

	static int tmImageLength[NTMFORMATS];

	Real matrix[2][2];

	virtual void propagationAlgorithm(AocsTime t);

	void localResetConfiguration();

public :

	TwoByTwoMatrixBlock();

	// Set element (i,j) of the matrix
	void setMatrixElement(int i, int j, Real value)
		{ matrix[i][j] = value; }

	virtual void resetConfiguration();

	virtual int getTelemetryImageLength();
	virtual void writeToTelemetry(TelemetryStream* stream);
};

#endif
