// SystemManagementTest.cpp 
//
// Version	1.0
// Date		23.01.01
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Test program for the system management facilities
// -------------------------------------------------------------------

// Include system header files
#include <stdio.h>

#include "../../GeneralUtilities/TestSuite.h"
#include "../../GeneralUtilities/TestUtilities.h"
#include "../../GeneralInclude/CompilerSwitches.h"
#include "TestCaseSystemManagement_1.h"

// -------------------------------------------------------------------

int main(int argc, char* argv[])
{
	// Open output file (only on MS_HOST)
	FILE* out=NULL;
#ifdef MS_HOST
    if( (out  = fopen("SystemManagementOut.txt","w")) == NULL )
      printf( "\nThe file 'SystemManagementOut' could not be opened\n" );   
	else
      printf( "\nThe file 'SystemManagementOut' was successfully opened\n" );
#endif

    printf( "\nBegin test for SystemManagement framelet ...\n" );
	printTestHeader(out, "SystemManagementOut");

	// Create test cases for class AocsObject
	TestCaseSystemManagement_1 testCase_1;

	// Create and load a test suite
	TestSuite testSuite(out);
	testSuite.loadTestCase(&testCase_1);

	// Run the test suite -- this causes all test cases in
	// the test suite to be run in sequence
	testSuite.runTestSuite();

    printf( "\nTest for SystemManagement framelet ended...\n" );

	// close output file
#ifdef MS_HOST
	fclose(out); 
#endif
	return 0;
}