// ManoeuvreTelecommand.cpp
//
// Version	1.0
// Date		25.11.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------

#include "../TelecommandManagement/ManoeuvreTelecommand.h"
#include "../ManoeuvreManagement/Manoeuvre.h"
#include "../ManoeuvreManagement/ManoeuvreManager.h"
#include "../GeneralInclude/ClassId.h"
#include "../AocsEvent/EventTypeId.h"

// -------------------------------------------------------------------
// Define static variables
ManoeuvreManager* ManoeuvreTelecommand::manoeuvreManager=NULL;

// -------------------------------------------------------------------

ManoeuvreTelecommand::ManoeuvreTelecommand(
	 AocsTime timeTag, Manoeuvre* m):Telecommand(timeTag)
{
	setClassId(ID_MANOEUVRETELECOMMAND);			

	manoeuvre = m;
}

// -------------------------------------------------------------------
// Simply load the manoeuvre into the manoeuvre manager. There is no
// check that the load operation was successful: the method always
// returns a "TC successful" code.

EventType ManoeuvreTelecommand::execute()
{
	manoeuvreManager->addManoeuvre(manoeuvre);

	return TC_SUCCESS;
}
