// Telecommand.h
//
// Version	1.0
// Date		05.08.00
// Author	A. Pasetti

#ifndef TelecommandH
#define TelecommandH

// -------------------------------------------------------------------
// Base class for Telecommands.
// -------------------------------------------------------------------

#include "../GeneralInclude/BasicTypes.h"
#include "../GeneralInclude/Constants.h"
#include "../GeneralInclude/ClassId.h"
#include "../BasicObjects/RootObject.h"
#include "../AocsEvent/EventTypeId.h"

// -------------------------------------------------------------------

class Telecommand : public RootObject {

	bool enabled;

	AocsTime timeTag;

public :

	Telecommand(AocsTime t)
		{ setClassId(ID_TELECOMMAND);
		  timeTag = t;
		  enabled = true;}

	virtual EventType execute()
		{ return TC_SUCCESS; }

	virtual bool canExecute()
		{ return true; }

	// Getter method for TC ID (mapped to instance ID)
	TelecommandId getTelecommandId()
		{ return getInstanceId(); }

	// Getter method for time tag
	AocsTime getTimeTag()
		{ return timeTag; }

	// Methods to manage the enable status
	void enable()
		{ enabled = true; }
	void disable()
		{ enabled = false; }
	virtual bool isEnabled()
		{ return enabled; }

};

// -------------------------------------------------------------------
#endif