// TelecommandManagementTest.cpp 
//
// Version	1.0
// Date		05.08.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Test program for the telecommand management framelet
// -------------------------------------------------------------------

// Include system header files
#include <stdio.h>

#include "../../GeneralUtilities/TestSuite.h"
#include "../../GeneralUtilities/TestUtilities.h"
#include "../../GeneralInclude/CompilerSwitches.h"
#include "TestCaseTelecommand_1.h"
#include "TestCaseTelecommand_2.h"
#include "TestCaseTelecommand_3.h"
#include "TestCaseTelecommand_4.h"
#include "TestCaseTelecommand_5.h"
#include "TestCaseTelecommand_6.h"
#include "TestCaseTelecommand_7.h"

// -------------------------------------------------------------------

int main(int argc, char* argv[])
{
	// Open output file (only on MS_HOST)
	FILE* out=NULL;
#ifdef MS_HOST
    if( (out  = fopen("TelecommandTestOut.txt","w")) == NULL )
      printf( "\nThe file 'TelecommandTestOut' could not be opened\n" );   
	else
      printf( "\nThe file 'TelecommandTestOut' was successfully opened\n" );
#endif

    printf( "\nBegin test for the telecommand framelet ...\n" );
	printTestHeader(out, "TelecommandTest");

	// Create test cases 
	TestCaseTelecommand_1 testCase_1;
	TestCaseTelecommand_2 testCase_2;
	TestCaseTelecommand_3 testCase_3;
	TestCaseTelecommand_4 testCase_4;
	TestCaseTelecommand_5 testCase_5;
	TestCaseTelecommand_6 testCase_6;
	TestCaseTelecommand_7 testCase_7;

	// Create and load a test suite
	TestSuite testSuite(out);
	testSuite.loadTestCase(&testCase_1);
	testSuite.loadTestCase(&testCase_2);
	testSuite.loadTestCase(&testCase_3);
	testSuite.loadTestCase(&testCase_4);
	testSuite.loadTestCase(&testCase_5);
	testSuite.loadTestCase(&testCase_6);
	testSuite.loadTestCase(&testCase_7);

	// Run the test suite -- this causes all test cases in
	// the test suite to be run in sequence
	testSuite.runTestSuite();

    printf( "\nTest for the telecommand framelet ended...\n" );

	// close output file
#ifdef MS_HOST
	fclose(out); 
#endif
	return 0;
}