// CyclingTelemetryModeManager.h
//
// Version	1.0
// Date		07.04.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Class for the telemetry mode manager.
// The TM mode manager manages one single strategy: the telemetry list.
// The default mode manager is built on the cycling mode manager. It adds 
// casting operations to the getImplementer method. 
//
// -------------------------------------------------------------------

#ifndef CyclingTelemetryModeManagerH
#define CyclingTelemetryModeManagerH

// -------------------------------------------------------------------

#include "../GeneralInclude/ForwardDeclarations.h"
#include "../ModeManagement/CyclingModeManager.h"
#include "../TelemetryManagement/TelemetryModeManager.h"

// -------------------------------------------------------------------

class CyclingTelemetryModeManager : public CyclingModeManager,
									public TelemetryModeManager {

public :

	CyclingTelemetryModeManager(int numberOfModes, 
								 int defaultMode,
								  int maxNumberOfMonitors);

	// Methods inherited from the TelemetryModeManager interface 
	virtual void loadTelemetryList(int mode, ObjectListTemplate<Telemeterable>* tmList);
	virtual ObjectListTemplate<Telemeterable>* getTelemetryList();
};

// -------------------------------------------------------------------
#endif
