// MemorySection.h
//
// Version	1.0
// Date		11.04.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Memory Section class (encapsulate a range of raw memory address to
// allow dumps of memory areas to telemetry)
// -------------------------------------------------------------------

#ifndef MemorySectionH
#define MemorySectionH

// -------------------------------------------------------------------

#include "../GeneralInclude/ForwardDeclarations.h"
#include "../GeneralInclude/Constants.h"
#include "../BasicObjects/AocsObject.h"

// -------------------------------------------------------------------

class MemorySection : public AocsObject {

	static int tmImageLength[NTMFORMATS];

	// Start and end address and length (in bytes) of memory section
	char* startAddress;
	char* endAddress;
	int sectionLength;

	// Local reset configuration method
	void localResetConfiguration();

public:

	// Constructor
	MemorySection();

	// Define the memory section
	void defineMemorySection(char* startAddress, char* endAddress);

	// pure virtual methods from Configurable
	virtual void resetConfiguration();		
	virtual bool isConfigured();		
	
	// Virtual methods inherited from interface Telemeterable
	virtual void writeToTelemetry(TelemetryStream* stream);
	virtual int getTelemetryImageLength();

};

// -------------------------------------------------------------------
#endif