// TelemetryManagementTest.cpp 
//
// Version	1.0
// Date		07.04.00
// Author	A. Pasetti
//
// -------------------------------------------------------------------
// Test program for the telemetry management framelet
// -------------------------------------------------------------------

// Include system header files
#include <stdio.h>

#include "../../GeneralUtilities/TestSuite.h"
#include "../../GeneralUtilities/TestUtilities.h"
#include "../../GeneralInclude/CompilerSwitches.h"
#include "TestCaseTelemetry_1.h"
#include "TestCaseTelemetry_2.h"
#include "TestCaseTelemetry_3.h"

// -------------------------------------------------------------------

int main(int argc, char* argv[])
{
	// Open output file (only on MS_HOST)
	FILE* out=NULL;
#ifdef MS_HOST
    if( (out  = fopen("TelemetryManagementTestOut.txt","w")) == NULL )
      printf( "\nThe file 'TelemetryManagementTestOut' could not be opened\n" );   
	else
      printf( "\nThe file 'TelemetryManagementTestOut' was successfully opened\n" );
#endif

    printf( "\nBegin test for the telemetry management framelet ...\n" );
	printTestHeader(out, "TelemetryManagementTest");

	// Create test cases 
	TestCaseTelemetry_1 testCase_1;
	TestCaseTelemetry_2 testCase_2;
	TestCaseTelemetry_3 testCase_3;

	// Create and load a test suite
	TestSuite testSuite(out);
	testSuite.loadTestCase(&testCase_1);
	testSuite.loadTestCase(&testCase_2);
	testSuite.loadTestCase(&testCase_3);

	// Run the test suite -- this causes all test cases in
	// the test suite to be run in sequence
	testSuite.runTestSuite();

    printf( "\nTest for the telemetry management framelet ended...\n" );

	// close output file
#ifdef MS_HOST
	fclose(out); 
#endif
	return 0;
}