

/****************************************************************************
|                   AutoCode/C (TM) Code Generator
|            INTEGRATED SYSTEMS INC.,   SUNNYVALE, CALIFORNIA
*****************************************************************************
rtf filename           : /a/estwns/users/esther/pasetti/c_tpl/integratortest.rtf
Filename               : /a/estwns/users/esther/pasetti/c_tpl/integratortest.c
Dac filename           : c_sdk.dac
Generated on           : Fri Mar  3 11:47:26 2000
Dac file created on    : Fri Mar  3 11:47:26 2000

                AutoCode Procedure Software Development Kit
*/



#include <stdio.h>
#include <math.h>
#include "sa_sys.h"
#include "sa_defn.h"
#include "sa_types.h"
#include "sa_math.h"
#include "sa_user.h"
#include "sa_utils.h"
#include "sa_time.h"
#include "sa_fuzzy.h"

#include "/a/estwns/users/esther/pasetti/c_tpl/integratortest.h"




/*** System Data ***/

/******* Structure to drive disconnected input/output. *******/








#define EPSILON                      1.49011611938476562E-08
#define EPS                          (4.0 * EPSILON)
#define ABSTOL                       EPSILON
#define XREMAP                       1




/* Xmath %var parameter variables */
VAR_FLOAT integratorgain = 5.0;
VAR_FLOAT integratorinit = 3.0;




/******** Procedures' declarations ********/


 void integrator(
          struct _integrator_u *U
          , struct _integrator_y *Y
          , struct _integrator_s *S
          , struct _integrator_info *I
          );
          



/******** Procedures' definitions ********/
static
/******* Procedure: integrator *******/
void integrator(   struct _integrator_u *U
   ,struct _integrator_y *Y
   ,struct _integrator_s *S
   ,struct _integrator_info *I
)
{
      RT_INTEGER *iinfo = &I->iinfo[0];
      RT_FLOAT *rinfo = &I->rinfo[0];
      RT_INTEGER INIT = iinfo[1];

      /***** Current and Next States Pointers. *****/

      struct _integrator_ps *X = &S->integrator_ps[S->integrator_x];
      struct _integrator_ps *XD = &S->integrator_ps[1-S->integrator_x];

      const RT_DURATION TSAMP   = rinfo[1];

      /******* Initialization. *******/

      if( INIT ) {
         X->integrator_2_S1 = 0.0;
         XD->integrator_2_S1 = 0.0;
         X->integrator_2_S1 = (*I->integratorinit);
      }


      /***** Output Update. *****/
      /* ----------------------------  Integrator */
      /* {integrator..2} */
      if (INIT && XREMAP) {
         X->integrator_2_S1 = X->integrator_2_S1 - 0.5*TSAMP*U->integrator_1; 
      }
      Y->integrator_2_1 = X->integrator_2_S1 + 0.5*TSAMP*U->integrator_1; 
      Y->integrator_2_1 = (*I->integratorgain)*Y->integrator_2_1; 

      /***** State Update. *****/
      /* ----------------------------  Integrator */
      /* {integrator..2} */
      XD->integrator_2_S1 = X->integrator_2_S1 + TSAMP*U->integrator_1; 


      iinfo[1] = 0;
EXEC_ERROR: return;
}




/* *********************************************************************
   *********************************************************************
   *********************************************************************
*/

/****** 
******* Interfaces to: integrator 
*******/

void integrator_Initialize(struct _integrator_ext *_idata)
{
   
   void *theInfo[10];
   
   _idata->integrator_i.iinfo[0] = 0;
   _idata->integrator_i.iinfo[1] = 1;
   _idata->integrator_i.iinfo[2] = 1;
   _idata->integrator_i.iinfo[3] = 1;
   
   _idata->integrator_s_s.integrator_x = 0;
   
   _idata->integrator_i.rinfo[0] = 0.0;   /* CURRENT TIME? */
   _idata->integrator_i.rinfo[1] = 1.0 / (RT_FLOAT)4.54545454545454586; /*Sample interval (sec)*/
   _idata->integrator_i.rinfo[2] = 0.0;   /* Skew (sec)*/
   _idata->integrator_i.rinfo[3] = 0.0;   /* not applicable */
   _idata->integrator_i.rinfo[4] = 0.0;   /* not applicable */
   
   theInfo[0] = (void*)&_idata->integrator_i;
      ((struct _integrator_info *)theInfo[0])->integratorgain = &integratorgain;
      ((struct _integrator_info *)theInfo[0])->integratorinit = &integratorinit;
      
   
}

RT_INTEGER integrator_Execute(
                    struct _integrator_u *U,
                    struct _integrator_y *Y,
                    RT_FLOAT TIME,
                    struct _integrator_ext *_idata)
                    
{
   /* -------------- Procedure Super Block: integrator */
   _idata->integrator_i.rinfo[0] = TIME;
   integrator(U, Y, &_idata->integrator_s_s, &_idata->integrator_i);
   _idata->integrator_s_s.integrator_x = 1 - _idata->integrator_s_s.integrator_x;
   
   return _idata->integrator_i.iinfo[0];
   
}







