

/****************************************************************************
|                   AutoCode/C (TM) Code Generator
|            INTEGRATED SYSTEMS INC.,   SUNNYVALE, CALIFORNIA
*****************************************************************************
rtf filename           : /a/estwns/users/esther/pasetti/c_tpl/pid.rtf
Filename               : /a/estwns/users/esther/pasetti/c_tpl/pid.c
Dac filename           : c_sdk.dac
Generated on           : Fri Mar  3 12:29:05 2000
Dac file created on    : Fri Mar  3 12:29:05 2000

                AutoCode Procedure Software Development Kit
*/



#include <stdio.h>
#include <math.h>
#include "sa_sys.h"
#include "sa_defn.h"
#include "sa_types.h"
#include "sa_math.h"
#include "sa_user.h"
#include "sa_utils.h"
#include "sa_time.h"
#include "sa_fuzzy.h"

#include "/a/estwns/users/esther/pasetti/c_tpl/pid.h"




/*** System Data ***/

/******* Structure to drive disconnected input/output. *******/








#define EPSILON                      1.49011611938476562E-08
#define EPS                          (4.0 * EPSILON)
#define ABSTOL                       EPSILON
#define XREMAP                       1




/* Xmath %var parameter variables */
VAR_FLOAT kp = 0.0;
VAR_FLOAT ki = 0.0;
VAR_FLOAT kd = 0.0;
VAR_FLOAT timeconstant = 0.1;




/******** Procedures' declarations ********/


 void pid(
          struct _pid_u *U
          , struct _pid_y *Y
          , struct _pid_s *S
          , struct _pid_info *I
          );
          



/******** Procedures' definitions ********/
static
/******* Procedure: pid *******/
void pid(   struct _pid_u *U
   ,struct _pid_y *Y
   ,struct _pid_s *S
   ,struct _pid_info *I
)
{
      RT_INTEGER *iinfo = &I->iinfo[0];
      RT_FLOAT *rinfo = &I->rinfo[0];
      RT_INTEGER INIT = iinfo[1];

      /***** Current and Next States Pointers. *****/

      struct _pid_ps *X = &S->pid_ps[S->pid_x];
      struct _pid_ps *XD = &S->pid_ps[1-S->pid_x];

      const RT_DURATION TSAMP   = rinfo[1];

      /***** Algorithmic Local Variables. *****/

      RT_FLOAT xn;

      /******* Initialization. *******/

      if( INIT ) {
         X->pid_S1 = 0.0;
         X->pid_S2 = 0.0;
         XD->pid_S1 = 0.0;
         XD->pid_S2 = 0.0;
      }


      /***** Output Update. *****/
      /* ----------------------------  PID Controller */
      /* {pid.pid.3} */
      Y->pid_1 = U->pid_1*(*I->kp); 

      /***** State Update. *****/
      /* ----------------------------  PID Controller */
      /* {pid.pid.3} */


      iinfo[1] = 0;
EXEC_ERROR: return;
}




/* *********************************************************************
   *********************************************************************
   *********************************************************************
*/

/****** 
******* Interfaces to: pid 
*******/

void pid_Initialize(struct _pid_ext *_idata)
{
   
   void *theInfo[10];
   
   _idata->pid_i.iinfo[0] = 0;
   _idata->pid_i.iinfo[1] = 1;
   _idata->pid_i.iinfo[2] = 1;
   _idata->pid_i.iinfo[3] = 1;
   
   _idata->pid_s_s.pid_x = 0;
   
   _idata->pid_i.rinfo[0] = 0.0;   /* CURRENT TIME? */
   _idata->pid_i.rinfo[1] = 1.0 / (RT_FLOAT)10.0; /*Sample interval (sec)*/
   _idata->pid_i.rinfo[2] = 0.0;   /* Skew (sec)*/
   _idata->pid_i.rinfo[3] = 0.0;   /* not applicable */
   _idata->pid_i.rinfo[4] = 0.0;   /* not applicable */
   
   theInfo[0] = (void*)&_idata->pid_i;
      ((struct _pid_info *)theInfo[0])->kp = &kp;
      ((struct _pid_info *)theInfo[0])->ki = &ki;
      ((struct _pid_info *)theInfo[0])->kd = &kd;
      ((struct _pid_info *)theInfo[0])->timeconstant = &timeconstant;
      
   
}

RT_INTEGER pid_Execute(
                    struct _pid_u *U,
                    struct _pid_y *Y,
                    RT_FLOAT TIME,
                    struct _pid_ext *_idata)
                    
{
   /* -------------- Procedure Super Block: pid */
   _idata->pid_i.rinfo[0] = TIME;
   pid(U, Y, &_idata->pid_s_s, &_idata->pid_i);
   _idata->pid_s_s.pid_x = 1 - _idata->pid_s_s.pid_x;
   
   return _idata->pid_i.iinfo[0];
   
}







