

/****************************************************************************
|                   AutoCode/C (TM) Code Generator
|            INTEGRATED SYSTEMS INC.,   SUNNYVALE, CALIFORNIA
*****************************************************************************
rtf filename           : /a/estwns/users/esther/pasetti/cpp_tpl/ramptest.rtf
Filename               : /a/estwns/users/esther/pasetti/cpp_tpl/ramptest.c
Dac filename           : cpp_sdk.dac
Generated on           : Fri Mar  3 12:27:00 2000
Dac file created on    : Fri Mar  3 12:27:00 2000

                AutoCode Procedure Software Development Kit
*/



#include <stdio.h>
#include <math.h>
#include "sa_sys.h"
#include "sa_defn.h"
#include "sa_types.h"
#include "sa_math.h"
#include "sa_user.h"
#include "sa_utils.h"
#include "sa_time.h"
#include "sa_fuzzy.h"

#include "/a/estwns/users/esther/pasetti/cpp_tpl/ramptest.h"




/*** System Data ***/

/******* Structure to drive disconnected input/output. *******/








#define EPSILON                      1.49011611938476562E-08
#define EPS                          (4.0 * EPSILON)
#define ABSTOL                       EPSILON
#define XREMAP                       1




/* Xmath %var parameter variables */
VAR_FLOAT integratorgain = 5.0;
VAR_FLOAT integratorinit = 3.0;
VAR_FLOAT starttime = 0.0;
VAR_FLOAT slope = 0.0;




/******** Procedures' declarations ********/


 void ramp(
          struct _ramp_y *Y
          , struct _ramp_s *S
          , struct _ramp_info *I
          );
          



/******** Procedures' definitions ********/
static
/******* Procedure: ramp *******/
void ramp(   struct _ramp_y *Y
   ,struct _ramp_s *S
   ,struct _ramp_info *I
)
{
      RT_INTEGER *iinfo = &I->iinfo[0];
      RT_FLOAT *rinfo = &I->rinfo[0];
      RT_INTEGER INIT = iinfo[1];

      /***** Current and Next States Pointers. *****/

      struct _ramp_ps *X = &S->ramp_ps[S->ramp_x];
      struct _ramp_ps *XD = &S->ramp_ps[1-S->ramp_x];

      const RT_DURATION TIME    = rinfo[0];
      const RT_DURATION TSAMP   = rinfo[1];

      /***** Local Block Outputs. *****/

      RT_FLOAT ramp_3_1;

      /***** Algorithmic Local Variables. *****/

      RT_FLOAT tmod;

      /******* Initialization. *******/

      if( INIT ) {
         X->ramp_2_S1 = 0.0;
         XD->ramp_2_S1 = 0.0;
         X->ramp_2_S1 = (*I->integratorinit);
      }


      /***** Output Update. *****/
      /* ----------------------------  (Limited) Ramp */
      /* {ramp..3} */
      ramp_3_1 = 0.0; 
      tmod = TIME - (*I->starttime); 
      if (tmod >= 0.0) {
         ramp_3_1 = (*I->slope)*tmod; 
         if ((*I->slope) > 0.0) {
            ramp_3_1 = MIN(ramp_3_1,1.0); 
         }
         else if ((*I->slope) < 0.0) {
            ramp_3_1 = MAX(ramp_3_1,1.0); 
         }
      }
      /* ----------------------------  Integrator */
      /* {ramp..2} */
      if (INIT && XREMAP) {
         X->ramp_2_S1 = X->ramp_2_S1 - 0.5*TSAMP*ramp_3_1; 
      }
      Y->ramp_2_1 = X->ramp_2_S1 + 0.5*TSAMP*ramp_3_1; 
      Y->ramp_2_1 = (*I->integratorgain)*Y->ramp_2_1; 

      /***** State Update. *****/
      /* ----------------------------  Integrator */
      /* {ramp..2} */
      XD->ramp_2_S1 = X->ramp_2_S1 + TSAMP*ramp_3_1; 


      iinfo[1] = 0;
EXEC_ERROR: return;
}




/* *********************************************************************
   *********************************************************************
   *********************************************************************
*/

/////////////
////////////
/// ramp_proxy
///
///

ramp_proxy::ramp_proxy()
{
   
   void *theInfo[10];
   
   m_procdata.ramp_i.iinfo[0] = 0;
   m_procdata.ramp_i.iinfo[1] = 1;
   m_procdata.ramp_i.iinfo[2] = 1;
   m_procdata.ramp_i.iinfo[3] = 1;
   
   m_procdata.ramp_s_s.ramp_x = 0;
   
   m_procdata.ramp_i.rinfo[0] = 0.0;   /* CURRENT TIME? */
   m_procdata.ramp_i.rinfo[1] = 1.0 / (RT_FLOAT)4.54545454545454586; /*Sample interval (sec)*/
   m_procdata.ramp_i.rinfo[2] = 0.0;   /* Skew (sec)*/
   m_procdata.ramp_i.rinfo[3] = 0.0;   /* not applicable */
   m_procdata.ramp_i.rinfo[4] = 0.0;   /* not applicable */
   
   theInfo[0] = (void*)&m_procdata.ramp_i;
      ((struct _ramp_info *)theInfo[0])->starttime = &starttime;
      ((struct _ramp_info *)theInfo[0])->slope = &slope;
      ((struct _ramp_info *)theInfo[0])->integratorgain = &integratorgain;
      ((struct _ramp_info *)theInfo[0])->integratorinit = &integratorinit;
      
   
}

RT_INTEGER ramp_proxy::Execute(
                    struct _ramp_y *Y,
                    RT_FLOAT TIME)
                    
{ 
   /* -------------- Procedure Super Block: ramp */
   m_procdata.ramp_i.rinfo[0] = TIME;
   ramp(Y, &m_procdata.ramp_s_s, &m_procdata.ramp_i);
   m_procdata.ramp_s_s.ramp_x = 1 - m_procdata.ramp_s_s.ramp_x;
   
   return m_procdata.ramp_i.iinfo[0];
   
}







