/****************************************************************************
|                   AutoCode/C (TM) Code Generator
|            INTEGRATED SYSTEMS INC.,   SUNNYVALE, CALIFORNIA
*****************************************************************************
rtf filename           : /a/estwns/users/esther/pasetti/cpp_tpl/ramptest.rtf
Filename               : /a/estwns/users/esther/pasetti/cpp_tpl/ramptest.h
Dac filename           : cpp_sdk.dac
Generated on           : Fri Mar  3 12:27:00 2000
Dac file created on    : Fri Mar  3 12:27:00 2000

                AutoCode Procedure Software Development Kit

Procedure Name                   Inputs  Outputs  INFO  States
--------------------------------------------------------------
ramp                             NO      YES      YES   YES

*/

#ifndef _TOPLEVEL_RAMP_H_
#define _TOPLEVEL_RAMP_H_

#include "sa_sys.h"
#include "sa_types.h"



/******* Procedure: ramp *******/

/***** Outputs type declaration. *****/
struct _ramp_y {
   RT_FLOAT ramp_2_1;
};


/***** Private States type declaration. *****/
struct _ramp_ps {
   RT_FLOAT ramp_2_S1;
};


/***** States type declaration. *****/
struct _ramp_s {
   struct _ramp_ps ramp_ps[2];
   RT_INTEGER ramp_x;
};


/***** Info type declaration. *****/
struct _ramp_info {
   RT_INTEGER iinfo[5];
   RT_FLOAT rinfo[5];
   VAR_FLOAT *starttime;
   VAR_FLOAT *slope;
   VAR_FLOAT *integratorgain;
   VAR_FLOAT *integratorinit;
};







// /////////////////////////////////////////////////////////////
// /////////////////////////////////////////////////////////////
// /////////////////////////////////////////////////////////////
// /////////////////////////////////////////////////////////////

//
//
//  CLASS: ramp_proxy
//
//
class ramp_proxy
{

/////
///// methods
/////
public:

    
    /////// Default Constructor
    //
    ramp_proxy();
    
    
    //Function: Execute
    //
    // Abstract: Execute the procedure
    //
    // Parameters: Procedure's input and output variables
    //             Current time may be needed as well.
    //             Interface varies for each procedure.
    //
    // Returns: error status, 0 = no error, 
    //          else see errors in sa_defn.h
    //
    //
    RT_INTEGER Execute(
                    struct _ramp_y *Y,
                    RT_FLOAT TIME);
                    

/////
/////  private data
/////
private:

    struct _ramp_ext {
         struct _ramp_info ramp_i;
         struct _ramp_s    ramp_s_s;
    } m_procdata;
    

};




#endif

