/****************************************************************************
|                   AutoCode/C (TM) Code Generator 62mx1118
|            INTEGRATED SYSTEMS INC.,   SUNNYVALE, CALIFORNIA
*****************************************************************************
rtf filename           : /a/estwns/users/esther/pasetti/ramptesttop.rtf
Filename               : /a/estwns/users/esther/pasetti/ramptesttop.c
Dac filename           : /opt/ISIHOME/solaris_mx_62.2/case/ACC/templates/c_sim.dac
Generated on           : Thu Mar  2 18:18:20 2000
Dac file created on    : Thu Nov 18 18:45:46 1999
Options                : -l c -procs


*/



#include <stdio.h>
#include <math.h>
#include "sa_sys.h"
#include "sa_defn.h"
#include "sa_types.h"
#include "sa_math.h"
#include "sa_matrix.h"
#include "sa_user.h"
#include "sa_utils.h"
#include "sa_time.h"
#include "sa_fuzzy.h"


// Control flag to avoid compilation of subsys version of autocode routine
#define SBUSER	1		// added by A. Pasetti





/*** System Data ***/

/******* Structure to drive disconnected input/output. *******/






#define EPSILON                      1.49011611938476562E-08
#define EPS                          (4.0 * EPSILON)
#define ABSTOL                       EPSILON
#define XREMAP                       1


/* Xmath variable definitions. */
VAR_FLOAT integratorgain;
VAR_FLOAT integratorinit;
VAR_FLOAT starttime;
VAR_FLOAT slope;
/* Xmath variable declarations. */
extern VAR_FLOAT integratorgain;
extern VAR_FLOAT integratorinit;
extern VAR_FLOAT starttime;
extern VAR_FLOAT slope;


/******** Procedures' declarations ********/

/******* Procedure: ramp *******/

/***** Outputs type declaration. *****/
struct _ramp_y {
   RT_FLOAT ramp_2_1;
};


/***** Private States type declaration. *****/
struct _ramp_ps {
   RT_FLOAT ramp_2_S1;
};


/***** States type declaration. *****/
struct _ramp_s {
   struct _ramp_ps ramp_ps[2];
   RT_INTEGER ramp_x;
};


/***** Info type declaration. *****/
struct _ramp_info {
   RT_INTEGER iinfo[5];
   RT_FLOAT rinfo[5];
   VAR_FLOAT *starttime;
   VAR_FLOAT *slope;
   VAR_FLOAT *integratorgain;
   VAR_FLOAT *integratorinit;
};





extern void ramp(struct _ramp_y *Y, struct _ramp_s *S, struct _ramp_info *I);


/******** Procedures' definitions ********/

/******* Procedure: ramp *******/
void ramp(   struct _ramp_y *Y
   ,struct _ramp_s *S
   ,struct _ramp_info *I
)
{
      RT_INTEGER *iinfo = &I->iinfo[0];
      RT_FLOAT *rinfo = &I->rinfo[0];
      RT_INTEGER INIT = iinfo[1];

      /***** Current and Next States Pointers. *****/

      struct _ramp_ps *X = &S->ramp_ps[S->ramp_x];
      struct _ramp_ps *XD = &S->ramp_ps[1-S->ramp_x];

      const RT_DURATION TIME    = rinfo[0];
      const RT_DURATION TSAMP   = rinfo[1];

      /***** Local Block Outputs. *****/

      RT_FLOAT ramp_1;

      /***** Algorithmic Local Variables. *****/

      RT_FLOAT tmod;

      /******* Initialization. *******/

      if( INIT ) {
         X->ramp_2_S1 = 0.0;
         XD->ramp_2_S1 = 0.0;
         X->ramp_2_S1 = (*I->integratorinit);
      }


      /***** Output Update. *****/
      /* ----------------------------  (Limited) Ramp */
      /* {ramp.ramp.3} */
      ramp_1 = 0.0; 
      tmod = TIME - (*I->starttime); 
      if (tmod >= 0.0) {
         ramp_1 = (*I->slope)*tmod; 
      }
      /* ----------------------------  Integrator */
      /* {ramp..2} */
      if (INIT && XREMAP) {
         X->ramp_2_S1 = X->ramp_2_S1 - 0.5*TSAMP*ramp_1; 
      }
      Y->ramp_2_1 = X->ramp_2_S1 + 0.5*TSAMP*ramp_1; 
      Y->ramp_2_1 = (*I->integratorgain)*Y->ramp_2_1; 

      /***** State Update. *****/
      /* ----------------------------  Integrator */
      /* {ramp..2} */
      XD->ramp_2_S1 = X->ramp_2_S1 + TSAMP*ramp_1; 


      iinfo[1] = 0;

EXEC_ERROR: return;
}



static void Init_Application_Data ()
{
   RT_INTEGER cnt;

     /* Declare %var/varblk initialization data */

     /* Xmath variables initialization. */
     integratorgain = 5.0;
     integratorinit = 3.0;
     starttime = 20.0;
     slope = 2.0;


}


#ifndef SBUSER

#define NTASKS                        1
static RT_INTEGER                     ERROR_FLAG  [NTASKS+1];
static RT_BOOLEAN                     SUBSYS_PREINIT [NTASKS+1];
static RT_BOOLEAN                     SUBSYS_INIT [NTASKS+1];
static RT_DURATION                    SUBSYS_TIME [NTASKS+1];

/******* System Ext I/O type declarations. *******/
struct _Subsys_1_out {
   RT_FLOAT ramp_2_1;
};

struct _Sys_ExtIn {
   RT_FLOAT ramptesttop_1;
   RT_FLOAT ramptesttop_2;
};





/*****************************************************************************/
/* (Subsystem-style) Wrapper (subsys_1) around procedure(s):                 */
/*                    ramp()                                                 */
/* to support invoking it from a user application.                           */
/*****************************************************************************/
/*
extern void subsys_1(  struct _Sys_ExtIn *U, struct _Subsys_1_out *Y);
*/

/******* Subsystem 1  *******/

/*
void subsys_1(   struct _Sys_ExtIn *U
   ,struct _Subsys_1_out *Y
)*/
void ramptest_subsys_1(   struct _Sys_ExtIn *U
   ,struct _Subsys_1_out *Y
)
{
      static RT_INTEGER iinfo[4];
      static RT_INTEGER INIT;
      const RT_DURATION TIME  = SUBSYS_TIME[1];
      const RT_DURATION TSAMP = 0.22;
      static struct _ramp_y ramp_2_y;
      static struct _ramp_s ramp_2_s;
      static struct _ramp_info ramp_2_i;
      struct _ramp_info *ramp_i;

      /******* Initialization. *******/

      if (SUBSYS_PREINIT[1]) {
         iinfo[0] = 0; 
         iinfo[1] = 1; 
         iinfo[2] = 1; 
         iinfo[3] = 1; 
         INIT = 1; 
         ramp_2_s.ramp_x = 0;
         ramp_2_i.iinfo[0] = iinfo[0];
         ramp_2_i.iinfo[1] = iinfo[1];
         ramp_2_i.iinfo[3] = iinfo[3];
         ramp_2_i.rinfo[0] = (RT_FLOAT)TIME;
         ramp_2_i.rinfo[1] = (RT_FLOAT)TSAMP;

         /* Copy in variable pointers of procedure ramp */
         ramp_2_i.starttime = &starttime;
         ramp_2_i.slope = &slope;
         ramp_2_i.integratorgain = &integratorgain;
         ramp_2_i.integratorinit = &integratorinit;
         SUBSYS_PREINIT[1] = FALSE; 
         return;
      }

      /***** Output Update. *****/
      /* ----------------------------  Procedure Super Block */
      /* {ramp.2} */
      ramp_2_i.rinfo[0] = (RT_FLOAT)TIME;
      ramp(&ramp_2_y, &ramp_2_s, &ramp_2_i);
      ramp_2_s.ramp_x = 1 - ramp_2_s.ramp_x;
      Y->ramp_2_1 = ramp_2_y.ramp_2_1;
      iinfo[0] = ramp_2_i.iinfo[0];
      if( iinfo[0] != 0 ) {
         ramp_2_i.iinfo[0] = 0; goto EXEC_ERROR;
      }
      INIT = 0;

      iinfo[1] = 0;
      return;

EXEC_ERROR: ERROR_FLAG[1] = iinfo[0];
      iinfo[0]=0;
}

#endif /* SBUSER */



/* Required for linking generated procedures with SystemBuild simulator. */

#if (FC_)
#ifdef SBUSER
#define ramp_ucbhook ramp_ucbhook_
#endif
#endif

#ifdef PC
#define ramp_ucbhook RAMP_UCBHOOK
extern void RAMP_UCBHOOK();
#else
extern void ramp_ucbhook();
#endif





/*****************************************************************************/
/* (UCB-style) Wrapper around the procedure to support UCB (Fixed calltype)  */
/* interface.                                                                */
/* This routine may be called as a UCB from SystemBuild.                     */
/*****************************************************************************/

/*****************************************************************************/
/* $ucb(ramp,hook,ramp_ucbhook)                                              */
/* Map                                                                       */
/* ---                                                                       */
/* Number of Inputs:                     0                                   */
/* Number of Outputs:                    1                                   */
/* Number of States:                     1                                   */
/* Number of Integer parameters (I_P):   0                                   */
/* Number of Real parameters    (R_P):   0                                   */
/* Number of constant (xmath) variables: 4                                   */
/*                                                                           */
/*                                                                           */
/* Integer (I_P) and real (R_P) parameters will automatically be             */
/* initialized by procedures invoked by this wrapper.  However, enough I_P   */
/* and R_P space needs to be allocated (use map above) for initializing and  */
/* storing new parameter values.                                             */
/*****************************************************************************/


void ramp_ucbhook(iinfo, rinfo, U, NU, X, XD ,NX, Y, NY, R_P, I_P)
   int     iinfo[], I_P[], *NU, *NX, *NY;
   double  rinfo[], R_P[], U[], X[], XD[], Y[];
{
   static struct _ramp_y ramp_2_y;
   static struct _ramp_s ramp_2_s;
   static struct _ramp_info ramp_2_i;

   struct _ramp_s *ramp_s;
   struct _ramp_ps *ramp_ps;

   struct _ramp_info *ramp_i;


   if( (*NU != 0) || (*NY != 1) || (*NX != 1) ) {
      iinfo[0] = UCB_ERROR; goto EXEC_ERROR;
   }
   if( iinfo[1] == 1 ) {
      Init_Application_Data();
      if( iinfo[3] == 1 && *NX != 0 ) {
         return;
      }
   }

   /* Not all SIM init-modes supported */
   if( iinfo[1] > 1 ) {
      return;
   }

   /* ---------------------------- Procedure Super Block */
   /* {ramp.2} */


   /* Copy in states of procedure ramp */
   ramp_2_s.ramp_x = 0;
   ramp_ps = &ramp_2_s.ramp_ps[0];
   ramp_ps->ramp_2_S1 = X[0];

   /* Copy in status and control data of procedure ramp */
   ramp_2_i.iinfo[0] = iinfo[0];
   ramp_2_i.iinfo[1] = iinfo[1];
   ramp_2_i.iinfo[3] = iinfo[3];
   ramp_2_i.rinfo[0] = rinfo[0];
   ramp_2_i.rinfo[1] = rinfo[1];

   /* Copy in variable pointers of procedure ramp */
   ramp_2_i.starttime = &starttime;
   ramp_2_i.slope = &slope;
   ramp_2_i.integratorgain = &integratorgain;
   ramp_2_i.integratorinit = &integratorinit;

   ramp(&ramp_2_y, &ramp_2_s, &ramp_2_i);
   Y[0] = ramp_2_y.ramp_2_1;


   /* Copy out states of procedure ramp */
   ramp_ps = &ramp_2_s.ramp_ps[1];
   XD[0] = ramp_ps->ramp_2_S1;

   /*  Copy back into states  */
   if( iinfo[1] == 1 ) {
      
      /* Copy in states of procedure ramp */
      ramp_2_s.ramp_x = 0;
      ramp_ps = &ramp_2_s.ramp_ps[0];
      X[0] = ramp_ps->ramp_2_S1;
   }


   iinfo[0] = ramp_2_i.iinfo[0];
EXEC_ERROR: return;
}





