/*----------------------------------------------------------------------------
--                       AutoCode (TM) 62mx1118
--
--                         Copyright (C) 1999
--                       INTEGRATED SYSTEMS, INC.
--
--  Unpublished work - rights reserved under the U.S. Copyright Act.  Use,
--  duplication, or disclosure by the government is subject to restrictions
--  set forth in the ISI commercial license agreement.
**----------------------------------------------------------------------------
**
**  File       : sa_sys.h
**  Project    : Autocode/C
**
**  Abstract:
**
**      Defined system types.  This file should be the first AutoCode header
**      file which is included.
*/

#ifndef _SA_SYSTEM
#define _SA_SYSTEM

/*--------------------------------------------------------
One of the following must be defined (set to 1) either in 
this file or via the compiler invocation i.e.
   VAX:   cc/define=VAX file.c
   SUN:   cc -DSUN      file.c


define APOLLO      0
define DEC         0
define HP          0
define HP700       0
define IBM         0
define SGI         0
define SUN         0
define SOLARIS     0
define VAX         0
define OSF1	       0	

define _TMS320C30  0
define _TMS320C40  0
define MSWIN32     0
define MSVC32      1
--------------------------------------------------------*/

#define MSWIN32      1

#if (APOLLO||DEC||HP||HP700||IBM||SGI||SOLARIS||SUN||VAX||MSWIN32||OSF1)
#define WS_TARGET 1
#else
#define WS_TARGET 0
#endif

#if (AC1000 || RS_PSOS || RS_VXWORKS || RS_UNIX || C_PC || _TMS320C30 || _TMS320C40 || _NT)
#define AC100_TARGET 1
/*
** Cannot be both a WS_TARGET and an AC100_TARGET
*/
#undef  WS_TARGET
#define WS_TARGET 0
#else
#define AC100_TARGET 0
#endif


#if (!AC100_TARGET && !WS_TARGET)
 --> Error invalid system type
#endif


/* ----------------------------------------------------------------------------
** |  ANSI_PROTOTYPES defined     => ANSI style prototypes                    |
** |  ANSI_PROTOTYPES not defined => Kernighan & Ritchie 'C' style prototypes |
** ----------------------------------------------------------------------------
**
** Preprocessors for fully compliant ANSI C are requried to have __STDC__
** 'defined' to be 1.  However, many 'C' compilers support ANSI compiliant 
** prototypes, but the compiler itself is not fully ANSI compliant.  If this
** is the case for your compiler, define the ANSI_PROTOTYPES symbol when
** invoking the compiler.
*/

#ifndef ANSI_PROTOTYPES
#  if defined(__cplusplus) || defined(c_plusplus)
#    define ANSI_PROTOTYPES  1
#  else
#    if (__STDC__ || AC100_TARGET || VAX)
#      define ANSI_PROTOTYPES  1
#    else
#      define ANSI_PROTOTYPES  0
#    endif
#  endif
#endif


#ifdef EXTERNAL_C
#  undef EXTERNAL_C
#endif
#ifdef EXTERN_FUNC
#  undef EXTERN_FUNC
#endif

#if defined(__cplusplus) || defined(c_plusplus)
#  define EXTERNAL_C extern "C" 
#else
#  define EXTERNAL_C extern 
#endif

/* For MS compiler, elevate warning
** for floating-point constant overflow
**/
#ifdef MSWIN32
#pragma warning(4:4056)
#endif

#if (ANSI_PROTOTYPES)
#  define EXTERN_FUNC(funName,funPar) EXTERNAL_C funName funPar
#else
#  define EXTERN_FUNC(funName,funPar) EXTERNAL_C funName()
#endif

#if defined(VAXVMS) || defined(MSWIN32) || defined(MSVC32) || defined(__STDC__) || defined(__STDCPP__)
/* ANSI C preprocessors will not expand the arguments to a macro;
 * so we need to add a level of indirection to allow macro expansion of
 * arguments.  (Reiser preprocessors allowed the first arg to be expanded;
 * this method will allow both to be expanded, which is better than none.)
 */
#define JUXTAPOSE(a,b)      _JUXTAPOSE_aux(a,b)
#define _JUXTAPOSE_aux(a,b)      a##b

#else 
#if defined(sun)||defined(SUN)
    /*System V way: although BSD is true*/

#define JUXTAPOSE(a,b)	a/**/b

#else
#ifdef  BSD
    /*BSD way:*/

#define JUXTAPOSE(a,b) a\
b

#else
    /*System V way:*/
#define JUXTAPOSE(a,b)	a/**/b
#endif /* BSD */
#endif 
#endif



#endif
