/****************************************************************************
|                   AutoCode/C (TM) Code Generator 62mx1118
|            INTEGRATED SYSTEMS INC.,   SUNNYVALE, CALIFORNIA
*****************************************************************************
rtf filename           : /a/estwns/users/esther/pasetti/ucb/integratortest.rtf
Filename               : /a/estwns/users/esther/pasetti/ucb/integratortest.c
Dac filename           : /opt/ISIHOME/solaris_mx_62.2/case/ACC/templates/c_sim.dac
Generated on           : Fri Mar  3 12:20:36 2000
Dac file created on    : Thu Nov 18 18:45:46 1999
Options                : -l c -procs


*/



#include <stdio.h>
#include <math.h>
#include "sa_sys.h"
#include "sa_defn.h"
#include "sa_types.h"
#include "sa_math.h"
#include "sa_matrix.h"
#include "sa_user.h"
#include "sa_utils.h"
#include "sa_time.h"
#include "sa_fuzzy.h"







/*** System Data ***/

/******* Structure to drive disconnected input/output. *******/






#define EPSILON                      1.49011611938476562E-08
#define EPS                          (4.0 * EPSILON)
#define ABSTOL                       EPSILON
#define XREMAP                       1


/* Xmath variable definitions. */
VAR_FLOAT integratorgain;
VAR_FLOAT integratorinit;
/* Xmath variable declarations. */
extern VAR_FLOAT integratorgain;
extern VAR_FLOAT integratorinit;


/******** Procedures' declarations ********/

/******* Procedure: integrator *******/

/***** Inputs type declaration. *****/
struct _integrator_u {
   RT_FLOAT integrator_1;
};


/***** Outputs type declaration. *****/
struct _integrator_y {
   RT_FLOAT integrator_2_1;
};


/***** Private States type declaration. *****/
struct _integrator_ps {
   RT_FLOAT integrator_2_S1;
};


/***** States type declaration. *****/
struct _integrator_s {
   struct _integrator_ps integrator_ps[2];
   RT_INTEGER integrator_x;
};


/***** Info type declaration. *****/
struct _integrator_info {
   RT_INTEGER iinfo[5];
   RT_FLOAT rinfo[5];
   VAR_FLOAT *integratorgain;
   VAR_FLOAT *integratorinit;
};





extern void integrator(struct _integrator_u *U, struct _integrator_y *Y, struct _integrator_s *S, struct _integrator_info *I);


/******** Procedures' definitions ********/

/******* Procedure: integrator *******/
void integrator(   struct _integrator_u *U
   ,struct _integrator_y *Y
   ,struct _integrator_s *S
   ,struct _integrator_info *I
)
{
      RT_INTEGER *iinfo = &I->iinfo[0];
      RT_FLOAT *rinfo = &I->rinfo[0];
      RT_INTEGER INIT = iinfo[1];

      /***** Current and Next States Pointers. *****/

      struct _integrator_ps *X = &S->integrator_ps[S->integrator_x];
      struct _integrator_ps *XD = &S->integrator_ps[1-S->integrator_x];

      const RT_DURATION TSAMP   = rinfo[1];

      /******* Initialization. *******/

      if( INIT ) {
         X->integrator_2_S1 = 0.0;
         XD->integrator_2_S1 = 0.0;
         X->integrator_2_S1 = (*I->integratorinit);
      }


      /***** Output Update. *****/
      /* ----------------------------  Integrator */
      /* {integrator..2} */
      if (INIT && XREMAP) {
         X->integrator_2_S1 = X->integrator_2_S1 - 0.5*TSAMP*U->integrator_1; 
      }
      Y->integrator_2_1 = X->integrator_2_S1 + 0.5*TSAMP*U->integrator_1; 
      Y->integrator_2_1 = (*I->integratorgain)*Y->integrator_2_1; 

      /***** State Update. *****/
      /* ----------------------------  Integrator */
      /* {integrator..2} */
      XD->integrator_2_S1 = X->integrator_2_S1 + TSAMP*U->integrator_1; 


      iinfo[1] = 0;

EXEC_ERROR: return;
}



static void Init_Application_Data ()
{
   RT_INTEGER cnt;

     /* Declare %var/varblk initialization data */

     /* Xmath variables initialization. */
     integratorgain = 5.0;
     integratorinit = 3.0;


}


#ifndef SBUSER

#define NTASKS                        1
static RT_INTEGER                     ERROR_FLAG  [NTASKS+1];
static RT_BOOLEAN                     SUBSYS_PREINIT [NTASKS+1];
static RT_BOOLEAN                     SUBSYS_INIT [NTASKS+1];

/******* System Ext I/O type declarations. *******/
struct _Subsys_1_out {
   RT_FLOAT integrator_2_1;
};

struct _Sys_ExtIn {
   RT_FLOAT integratortesttop_1;
   RT_FLOAT integratortesttop_2;
};





/*****************************************************************************/
/* (Subsystem-style) Wrapper (subsys_1) around procedure(s):                 */
/*                    integrator()                                           */
/* to support invoking it from a user application.                           */
/*****************************************************************************/

extern void subsys_1(  struct _Sys_ExtIn *U, struct _Subsys_1_out *Y);


/******* Subsystem 1  *******/


void subsys_1(   struct _Sys_ExtIn *U
   ,struct _Subsys_1_out *Y
)
{
      static RT_INTEGER iinfo[4];
      static RT_INTEGER INIT;
      const RT_DURATION TSAMP = 0.22;
      static struct _integrator_u integrator_2_u;
      static struct _integrator_y integrator_2_y;
      static struct _integrator_s integrator_2_s;
      static struct _integrator_info integrator_2_i;
      struct _integrator_info *integrator_i;

      /******* Initialization. *******/

      if (SUBSYS_PREINIT[1]) {
         iinfo[0] = 0; 
         iinfo[1] = 1; 
         iinfo[2] = 1; 
         iinfo[3] = 1; 
         INIT = 1; 
         integrator_2_s.integrator_x = 0;
         integrator_2_i.iinfo[0] = iinfo[0];
         integrator_2_i.iinfo[1] = iinfo[1];
         integrator_2_i.iinfo[3] = iinfo[3];
         integrator_2_i.rinfo[1] = (RT_FLOAT)TSAMP;

         /* Copy in variable pointers of procedure integrator */
         integrator_2_i.integratorgain = &integratorgain;
         integrator_2_i.integratorinit = &integratorinit;
         SUBSYS_PREINIT[1] = FALSE; 
         return;
      }

      /***** Output Update. *****/
      /* ----------------------------  Procedure Super Block */
      /* {integrator.2} */
      integrator_2_u.integrator_1 = U->integratortesttop_1;
      integrator(&integrator_2_u, &integrator_2_y, &integrator_2_s, &
         integrator_2_i);
      integrator_2_s.integrator_x = 1 - integrator_2_s.integrator_x;
      Y->integrator_2_1 = integrator_2_y.integrator_2_1;
      iinfo[0] = integrator_2_i.iinfo[0];
      if( iinfo[0] != 0 ) {
         integrator_2_i.iinfo[0] = 0; goto EXEC_ERROR;
      }
      INIT = 0;

      iinfo[1] = 0;
      return;

EXEC_ERROR: ERROR_FLAG[1] = iinfo[0];
      iinfo[0]=0;
}

#endif /* SBUSER */



/* Required for linking generated procedures with SystemBuild simulator. */

#if (FC_)
#ifdef SBUSER
#define integrator_ucbhook integrator_ucbhook_
#endif
#endif

#ifdef PC
#define integrator_ucbhook INTEGRATOR_UCBHOOK
extern void INTEGRATOR_UCBHOOK();
#else
extern void integrator_ucbhook();
#endif





/*****************************************************************************/
/* (UCB-style) Wrapper around the procedure to support UCB (Fixed calltype)  */
/* interface.                                                                */
/* This routine may be called as a UCB from SystemBuild.                     */
/*****************************************************************************/

/*****************************************************************************/
/* $ucb(integrator,hook,integrator_ucbhook)                                  */
/* Map                                                                       */
/* ---                                                                       */
/* Number of Inputs:                     1                                   */
/* Number of Outputs:                    1                                   */
/* Number of States:                     1                                   */
/* Number of Integer parameters (I_P):   0                                   */
/* Number of Real parameters    (R_P):   0                                   */
/* Number of constant (xmath) variables: 2                                   */
/*                                                                           */
/*                                                                           */
/* Integer (I_P) and real (R_P) parameters will automatically be             */
/* initialized by procedures invoked by this wrapper.  However, enough I_P   */
/* and R_P space needs to be allocated (use map above) for initializing and  */
/* storing new parameter values.                                             */
/*****************************************************************************/


void integrator_ucbhook(iinfo, rinfo, U, NU, X, XD ,NX, Y, NY, R_P, I_P)
   int     iinfo[], I_P[], *NU, *NX, *NY;
   double  rinfo[], R_P[], U[], X[], XD[], Y[];
{
   static struct _integrator_u integrator_2_u;
   static struct _integrator_y integrator_2_y;
   static struct _integrator_s integrator_2_s;
   static struct _integrator_info integrator_2_i;

   struct _integrator_s *integrator_s;
   struct _integrator_ps *integrator_ps;

   struct _integrator_info *integrator_i;


   if( (*NU != 1) || (*NY != 1) || (*NX != 1) ) {
      iinfo[0] = UCB_ERROR; goto EXEC_ERROR;
   }
   if( iinfo[1] == 1 ) {
      Init_Application_Data();
      if( iinfo[3] == 1 && *NX != 0 ) {
         return;
      }
   }

   /* Not all SIM init-modes supported */
   if( iinfo[1] > 1 ) {
      return;
   }

   /* ---------------------------- Procedure Super Block */
   /* {integrator.2} */
   integrator_2_u.integrator_1 = U[0];


   /* Copy in states of procedure integrator */
   integrator_2_s.integrator_x = 0;
   integrator_ps = &integrator_2_s.integrator_ps[0];
   integrator_ps->integrator_2_S1 = X[0];

   /* Copy in status and control data of procedure integrator */
   integrator_2_i.iinfo[0] = iinfo[0];
   integrator_2_i.iinfo[1] = iinfo[1];
   integrator_2_i.iinfo[3] = iinfo[3];
   integrator_2_i.rinfo[1] = rinfo[1];

   /* Copy in variable pointers of procedure integrator */
   integrator_2_i.integratorgain = &integratorgain;
   integrator_2_i.integratorinit = &integratorinit;

   integrator(&integrator_2_u, &integrator_2_y, &integrator_2_s, &
      integrator_2_i);
   Y[0] = integrator_2_y.integrator_2_1;


   /* Copy out states of procedure integrator */
   integrator_ps = &integrator_2_s.integrator_ps[1];
   XD[0] = integrator_ps->integrator_2_S1;

   /*  Copy back into states  */
   if( iinfo[1] == 1 ) {
      
      /* Copy in states of procedure integrator */
      integrator_2_s.integrator_x = 0;
      integrator_ps = &integrator_2_s.integrator_ps[0];
      X[0] = integrator_ps->integrator_2_S1;
   }


   iinfo[0] = integrator_2_i.iinfo[0];
EXEC_ERROR: return;
}





